/* 
   access.c: a real access function for the access-deficient implementations
   Copyright (C) 2007, 2008 Vincent Fourmond

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
#include <unistd.h>
#include <stdio.h>

#include <cfortran/cfortran.h>

int my_access(char * name, char * mode);

FCALLSCFUN2(INT,my_access,ACCESS,access,STRING,STRING)

int my_access(char *name, char *mode)
{
  char * file;
  int i;			/* Counter */
  int m;			/* Mode */
  int val;

  m = F_OK;
  for (i = 0; mode[i]; i++)
    switch (mode[i])
      {
      case ' ':
	break;
	
      case 'r':
      case 'R':
	m |= R_OK;
	break;
	 
      case 'w':
      case 'W':
	m |= W_OK;
	break;
	
      case 'x':
      case 'X':
	m |= X_OK;
	break;

      default:
	return -1;
	break;
      }
  
  val = access(name, m);
  return (val == 0 ? 0 : 1);
}
