/* 
   display_commands.c: nicely formats the list of available commands
   Copyright (C) 2007, 2008 Vincent Fourmond

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
#include <stdio.h>
#include "commands.h"
#include <cfortran/cfortran.h>

int display_commands()
{
  command_t * p = commands;
  char buffer[50];
  printf("Available commands:\n");
  while(p->cmd) {
    /* We skip fits */
    if(strncmp("fit_", p->cmd, 4) && strncmp("fit2_", p->cmd, 5) )
      {
	snprintf(buffer, sizeof(buffer), "(%s)", p->cmd);
	printf(" %-12s\t%s\n", buffer, p->help_text);
      }
    p++;
  }
}

FCALLSCSUB0(display_commands,DISPLAYCOMMANDS,displaycommands);

int display_fits()
{
  command_t * p = commands;
  char buffer[50];
  printf("Available fits:\n");
  while(p->cmd) {
    if(! strncmp("fit_", p->cmd, 4) || ! strncmp("fit2_", p->cmd, 5)) {
      snprintf(buffer, sizeof(buffer), "(%s)", p->cmd);
      printf(" %-12s\t%s\n", buffer, p->help_text);
    }
    p++;
  }
}

FCALLSCSUB0(display_fits,DISPLAYFITS,displayfits);
  
  
