/* C source for I1MACH -- http://www.netlib.org */
/* Vincent Fourmond: it is my understanding that
   this file is in the public domain
*/
#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include <limits.h>
#include <math.h>

#include <cfortran/cfortran.h>

/*#define i1mach_ F77_FUNC(i1mach,I1MACH)*/
#define r1mach_ F77_FUNC(r1mach,R1MACH)

long i1mach(long );
FCALLSCFUN1(INT,i1mach,I1MACH,i1mach,INT);
float r1mach(long);
FCALLSCFUN1(FLOAT,r1mach,R1MACH,r1mach,INT);

long i1mach(long i)
{
	switch(i){
          case 1:  return 5;	/* standard input */
	  case 2:  return 6;	/* standard output */
	  case 3:  return 7;	/* standard punch */
	  case 4:  return 0;	/* standard error */
	  case 5:  return 32;	/* bits per integer */
	  case 6:  return sizeof(int);
	  case 7:  return 2;	/* base for integers */
	  case 8:  return 31;	/* digits of integer base */
	  case 9:  return LONG_MAX;
	  case 10: return FLT_RADIX;
	  case 11: return FLT_MANT_DIG;
	  case 12: return FLT_MIN_EXP;
	  case 13: return FLT_MAX_EXP;
	  case 14: return DBL_MANT_DIG;
	  case 15: return DBL_MIN_EXP;
	  case 16: return DBL_MAX_EXP;
	  }
	fprintf(stderr, "invalid argument: i1mach(%ld)\n", i);
	exit(1);return 0; /* some compilers demand return values */
}


float r1mach(long i)
{
       switch(i){
         case 1: return FLT_MIN;
         case 2: return FLT_MAX;
         case 3: return FLT_EPSILON/FLT_RADIX;
         case 4: return FLT_EPSILON;
         case 5: return log10((double)FLT_RADIX);
         }
       fprintf(stderr, "invalid argument: r1mach(%ld)\n", i);
       exit(1); return 0; /* else complaint of missing return value */
}
