/* 
   soas_noscalc.c: placeholder for when scalc is not found.
   Copyright (C) 2007, 2008 Vincent Fourmond

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#include <cfortran/cfortran.h>
#include <stdio.h>

int scalcparse(const char * str)
{
  printf("Soas was compiled without scalc, there is no "
	 "arbirtrary fits support\n");
  return 0; 			/* always false */
}

FCALLSCFUN1(LOGICAL,scalcparse,SCALCPARSE,scalcparse,STRING);

int scalcparamnumber()
{
  return -1;
}

FCALLSCFUN0(INT,scalcparamnumber,SCALCPARAMNUMBER,scalcparamnumber);

const char * scalcparametername(int param)
{
  return "problem...";
}

FCALLSCFUN1(STRING,scalcparametername,SCALCPARAMETERNAME,
	    scalcparametername, INT);


void scalc_compute(int n, void * x_p, void * y_p, void * p_p)
{
  /* This function really should never be called. */
  printf("Soas was compiled without scalc, there is no "
	 "arbirtrary fits support\n");
  return;
}

FCALLSCSUB4(scalc_compute,SCALCCOMPUTE,scalccompute,INT,FLOATV,
	    FLOATVV, FLOATV);



void scalcinit()
{
  /* This function really should never be called. */
  printf("Soas was compiled without scalc, there is no "
	 "arbirtrary fits support\n");
  return;
}

FCALLSCSUB0(scalcinit,SCALCINIT,scalcinit)

void scalcprintvars()
{
  printf("Soas was compiled without scalc, there is no "
	 "arbirtrary fits support\n");
  return;
}

FCALLSCSUB0(scalcprintvars,SCALCPRINTVARS,scalcprintvars);

void scalcsettemperature(float t)
{
  printf("Soas was compiled without scalc, there is no "
	 "arbirtrary fits support\n");
  return;
}

FCALLSCSUB1(scalcsettemperature, SCALCSETTEMPERATURE,
	    scalcsettemperature, FLOAT); 

