C    soas_buff.f: baseline subtraction
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

c     spline base line

      subroutine baseline(npnew,xnew,ynew,areaold,datachanged)
      parameter (N=2**14,nmmax=50,nmp=10)
      logical datachanged,expert,displayRatio,derive,recompute,onlybase,ipeak!
      logical exportfiles       ! for development only
      integer marker            ! marker=1 on data, marker=2 smooth, 3 off data
      character*10 code
      real*8 xu,yu,xu1,xu2
      real*4 x4,y4,areaold,sigma
      real*4 bspl(nmmax),cspl(nmmax),dspl(nmmax)
      real*4 xnew(*),ynew(*),xc(nmmax),yc(nmmax),yb(N),yder(N) !,xi(N)
      logical xilog(N)
      integer npnew,nc,i,iZoomOut
      common /expert/ expert
      common /zoom/ iZoomOut    ! used in sub plot and reclim (soas_plot)
 309  format('ERROR : Unknown command ''',A,'''')
 303  format(A)
 302  format('INFO : last area was ',G12.4)
 301  format('INFO : area is now   ',G12.4)

c     
      exportfiles=.false.
c     

      call plot(npnew,xnew,ynew,1) 
      code(1:1)=' '
      sigma=0
      displayRatio=.true.       ! set to .not.(displayratio) typing t
      derive=.false.
      onlybase=.false.
      ipeak=.false.

      if (.not.expert) then
         write(6,303) 's,x,o to switch between Smooth/eXact/Off_data' !
         write(6,303) 'left   button or a to Add a marker' !
         write(6,303) 'right  button or r to Remove the nearest marker' !
         write(6,303) 'middle button or q to Quit and subtract baseline' !
         write(6,303) 'm to get More commands.' !
      endif
      if (areaold.ne.0.) write(6,302) areaold
      nc=0                      ! number of markers
      do i=1,n
         xilog(i)=.false.       ! true if a marker is set at position i
      enddo
      marker=1                  ! on data, exact

      do while ((code(1:1).ne.'&').and.(code(1:1).ne.'Q')
     :     .and.(code(1:1).ne.'U').and.(code(1:1).ne.'V')) !         
         if (marker.eq.1) then
            call gr_exec1('dr text 0 1 "Marker eXact" 3 /box 7') 
         elseif (marker.eq.2) then
            call gr_exec1('dr text 0 1 "Marker Smooth" 3 /box 7') 
         elseif (marker.eq.3) then
            call gr_exec1('dr text 0 1 "Marker Off data" 3 /box 7') 
         endif

         call gr_curs(xu,yu,x4,y4,code) 
         recompute=.true.

         if ((marker.ne.1).and.(code(1:1).eq.'X')) then ! exact
            marker=1
            if (.not.expert) write(6,303) 'INFO : marker set to eXact' !
            recompute=.false.

         elseif ((marker.eq.1).and.(code(1:1).eq.'X')) then ! exact
            if (.not.expert) write(6,303)
     :           'WARNING : marker already set to eXact' !
            recompute=.false.

         elseif ((marker.ne.2).and.(code(1:1).eq.'S')) then ! smooth
            marker=2
            if (.not.expert) write(6,303)
     :           'INFO : marker set to Smooth' !
            recompute=.false.

         elseif ((marker.eq.2).and.(code(1:1).eq.'S')) then ! smooth
            if (.not.expert) write(6,303)
     :           'WARNING : marker already set to Smooth' !
            recompute=.false.

         elseif ((marker.ne.3).and.(code(1:1).eq.'O')) then ! off data
            marker=3
            if (.not.expert) write(6,303)
     :           'INFO : marker set to Off data' !
            recompute=.false.

         elseif ((marker.eq.3).and.(code(1:1).eq.'O')) then ! off data 
            if (.not.expert) write(6,303)
     :           'WARNING : marker already set to Off data' !
            recompute=.false.

         elseif (code(1:1).eq.'-') then ! remove all markers
            do i=1,npnew
               xilog(i)=.false.
            enddo
            nc=0

         elseif (code(1:1).eq.'0') then ! add 2*nmp markers
            if (marker.eq.3) write(6,303)
     :           'WARNING: marker set to Off_data!' !
            displayratio=.false. ! likely 
            xu2=xnew(npnew)
            xu1=xnew(1)
            do i=1,2*nmp
               xu=xu1+(xu2-xu1)*real(i-1)/real(2*nmp-1)
               call addmarker(xc,yc,nc,xnew,xilog,
     :              ynew,npnew,marker,xu,yu) 
            enddo

         elseif (code(1:1).eq.'T') then ! .not.DisplayRatio
            displayRatio=.not.displayRatio
            recompute=.false.
            
         elseif (code(1:1).eq.'D') then ! .not.derive
            if (nc.lt.3) then
               write(6,303) 'ERROR : no baseline defined'
               recompute=.false.
            else
               if (.not.derive) then
                  derive=.true.
                  if (marker.eq.3) then ! marker is off data
                     marker=1
                     write(6,303) 'INFO : Market set to exact'
                  endif
               else
                  derive=.false.
               endif
               recompute=.true.
            endif

         elseif (((code(1:1).eq.'1').and.(xnew(npnew).gt.xnew(1))).or.
     :           (((code(1:1).eq.'2').and.(xnew(npnew).lt.xnew(1)))))
     :           then           ! add nmp markers before
            if (marker.eq.3) write(6,303)
     :           'WARNING: marker set to Off_data!' !
            xu2=xu
            xu1=xnew(1)
            do i=1,nmp
               xu=xu1+(xu2-xu1)*real(i-1)/real(nmp-1)
               call addmarker(xc,yc,nc,xnew,xilog,
     :              ynew,npnew,marker,xu,yu)
            enddo

         elseif (((code(1:1).eq.'1').and.(xnew(npnew).lt.xnew(1))).or. 
     :           (((code(1:1).eq.'2').and.(xnew(npnew).gt.xnew(1)))))
     :           then           ! add nmp markers after
            if (marker.eq.3) write(6,303)
     :           'WARNING: marker set to Off_data!' !
            xu1=xu
            xu2=xnew(npnew)
            do i=1,nmp
               xu=xu1+(xu2-xu1)*real(i-1)/real(nmp-1)
               call addmarker(xc,yc,nc,xnew,xilog,ynew,
     :              npnew,marker,xu,yu)
            enddo

         elseif ((code(1:1).eq.'^').or.(code(1:1).eq.'A')) then 
c     addmarker
            call addmarker(xc,yc,nc,xnew,xilog,ynew,npnew,marker,xu,yu) 

         elseif (((code(1:1).eq.'*').or.(code(1:1).eq.'R'))) then 
c     remove marker
            if (nc.ge.1) then   
               call removemarker(xc,yc,nc,xnew,xilog,ynew,npnew,xu) 
            else
               write(6,303) 'ERROR : no marker to remove'
               recompute=.false.
            endif

         elseif (code(1:1).eq.'Z') then 
            iZoomOut=iZoomOut+1 ! expand Y scale
            recompute=.false.

         elseif (code(1:1).eq.'I') then 
            iZoomOut=max(iZoomOut-1,0) ! shrink Y scale
            recompute=.false.

         elseif (code(1:1).eq.'P') then 
            ipeak=.not.ipeak
            recompute=.false.

         elseif (code(1:1).eq.'B') then 
            if (onlybase) then
               onlybase=.false.
            elseif (nc.lt.3) then
               write(6,303) 'ERROR : no baseline defined'
            elseif (derive) then
               write(6,303) 'ERROR : turn of derivation first'
            else
               onlybase=.true.
            endif
            recompute=.false.
            
         elseif (code(1:1).eq.'M') then
            write(6,303) 'u to qUit replacing data with baseline (!)' !
            write(6,303) 'v to quit replacing data with data/baseline' !
            write(6,303) 'b to get baseline full scale' ! 
            write(6,303) 'd to diplay derivative of the baseline' !
            write(6,303) 'b or d again to get back to normal display' !
            write(6,303) '1,2 to set 10 markers left/right of cursor' ! 
            write(6,303) '0 to set 20 evenly spaced markers' !
            write(6,303) '- to delete all markers' !
            write(6,303) 't to display/remove the raTio lines' !
            write(6,303) 'z,i to zoom out/in on Y axis' !
            write(6,303) 'p to turn on/off peak seach' !
            recompute=.false.
            
         elseif ((code(1:1).eq.'&').or.(code(1:1).eq.'Q')
     :           .or.(code(1:1).eq.'U').or.(code(1:1).eq.'V')) then
            continue            ! about to quit
            recompute=.false.

         elseif (expert.and.(code(1:1).eq.'N')) then ! expert mode only, export files
            exportfiles=.not.exportfiles
            recompute=.false.

         else
            if (.not.expert) write(6,309) code(1:1)
            recompute=.false.

         endif
         
         if (nc.ge.3) then      ! subtract base line
            if (recompute) then ! spline first step
c$$$  yp1=(yc(2)-yc(1))/(xc(2)-xc(1)) ! NR stuff deleted
c$$$  ypn=(yc(nc)-yc(nc-1))/(xc(nc)-xc(nc-1)) ! NR stuff deleted
c$$$  call spline(xc,yc,nc,yp1,ypn,y2) ! NR stuff deleted
               call spline_netlib(nc,xc,yc,bspl,cspl,dspl) ! in soas_numerical
            endif
            if (.not.derive) then
               if (recompute) then
                  do i=1,npnew
c$$$  call splint(xc,yc,y2,nc,xnew(i),yb(i)) ! NR stuff deleted
                     yb(i)=seval_netlib(nc,xnew(i),xc,yc,bspl,cspl,dspl,0) !
                  enddo         ! in soas_numerical
               endif            !recompute
               if (.not.onlybase) then

                  if (exportfiles) then
c     write out all files for making figure
                     call soas_system('rm exportfiles.dat')
                     open (unit=3,file='exportfiles.dat',status='new')
                     write(3,*)'!data'
                     do i=1,npnew
                        write(3,*) xnew(i),yb(i),ynew(i)
                     enddo
                     write(3,*)'!markers'
                     do i=1,nc
                        write(3,*) xc(i),yc(i)
                     enddo
                     close(3)
                  endif
               

                  call plot(npnew,xnew,ynew,1)
                  call plotdiff(xnew,yb,ynew,sigma,npnew,ipeak) ! plot sub data
                  call charge2(xnew,yb,ynew,npnew,areaold,displayratio)
                  call reclim(npnew,xnew,ynew) ! recover limit
                  call plot(npnew,xnew,yb,0) ! plot base line
               else             ! onlybase
                  call plot(npnew,xnew,yb,2) ! blue baseline full scale
                  call plotdiff(xnew,yb,ynew,sigma,npnew,ipeak) ! plot sub data
                  call charge2(xnew,yb,ynew,npnew,areaold,displayratio)
                  call reclim(npnew,xnew,yb) ! recover limits
                  call gr_exec1('dr text 0 1 "Baseline." 1 /box 9') !
               endif
            else                ! compute deriv of base line instead
               if (recompute) then
                  do i=1,npnew
c$$$  call splintb(xc,yc,y2,nc,xnew(i),yb(i),yder(i)) ! NR stuff deleted
                     yder(i)=seval_netlib(nc,xnew(i),xc,yc,bspl,cspl,dspl,1) !
                  enddo
               endif
               call plot(npnew,xnew,yder,2)
         call gr_exec1('dr text 0 1 "Derivative of Baseline." 1 /box 9') ! 
            endif  
         else                   ! raw data + markers hereafter 
            if (onlybase) onlybase=.false. 
            if (derive) derive=.false. 
            call plot(npnew,xnew,ynew,1) 
         endif
         if ((nc.ge.1).and.(.not.derive)) then
            call gr4_give('X',nc,xc)
            call gr4_give('Y',nc,yc)               
            call gr_exec1('poi') ! plot markers
         endif
      enddo  

c     quit
      if (nc.ge.3) then         ! if more than 3 markers
         if (.not.derive) then
            if (code(1:1).eq.'U') then
               do i=1,npnew
                  ynew(i)=yb(i) ! replace with base line
               enddo            
            elseif (code(1:1).eq.'V') then
               do i=1,npnew
                  ynew(i)=ynew(i)/yb(i) ! divide by base line
               enddo            
            else
               do i=1,npnew
                  ynew(i)=ynew(i)-yb(i) ! subtract base line
               enddo
            endif
            call plot(npnew,xnew,ynew,1)
            areaold=0.          ! update areaold 
            do i=2,npnew
               areaold=areaold+ynew(i)*(xnew(i)-xnew(i-1))
            enddo
            if (areaold.ne.0) write(6,301) areaold
         else
            do i=1,npnew
               ynew(i)=yder(i)
            enddo
         endif
         datachanged=.true.
      else
         write(6,303) 'INFO : data NOT changed'
         datachanged=.false.
      endif
      iZoomOut=0                ! reset scaling factor for Y scale
      return 
      end

c     **************************************************

      subroutine removemarker(xc,yc,nc,xnew,xilog,ynew,npnew,xu)
      parameter (N=2**14,nmmax=50)
      real*8 xu
      logical xilog(*)
      real*4 xnew(*),ynew(*),xc(nmmax),yc(nmmax),xu4,distmin!,xi(N)
      integer npnew,nc,ic,i,ic2
      xu4=xu
      distmin=1e20
      do i=1,nc
         if ((abs(xu4-xc(i))).lt.distmin) then
            distmin=abs(xu4-xc(i))
            ic=i
         endif
      enddo
      do i=ic,nc-1 ! remove this marker
         xc(i)=xc(i+1)
         yc(i)=yc(i+1)
      enddo
      nc=nc-1
      distmin=1e20
      do i=1,npnew
         if (((abs(xu4-xnew(i))).lt.distmin).and.(xilog(i))) then
            distmin=abs(xu4-xnew(i))
            ic2=i
         endif
      enddo
      xilog(ic2)=.false.! unmark the position alonb x: no marker anymore.
      return
      end

c     **************************************************

      subroutine addmarker(xc,yc,nc,xnew,xilog,ynew,npnew,marker,xu,yu)
      parameter (N=2**14,nmmax=50)
      integer marker            ! marker=1 on data, marker=2 smooth, 3 off data
      real*8 xu,yu
      logical xilog(*)
      real*4 xnew(*),ynew(*),xc(nmmax),yc(nmmax),distmin!,xi(N)
      integer npnew,nc,ic,i
 303  format(A)
      if (nc.ge.nmmax) then
         write(6,303) 'ERROR : too many markers ; please remove some'
      else
 304     format('WARNING : max number of markers is'//
     :        ' about to be reached (',I2,'/',I2,')') !
         if (nc.gt.int(real(nmmax)*.95)) write(6,304) nc,nmmax 
         xu4=xu         
         distmin=1e20
         do i=1,npnew
            if ((abs(xu4-xnew(i))).lt.distmin) then
               distmin=abs(xu4-xnew(i))
               ic=i
            endif
         enddo
         if (.not.xilog(ic)) then 
            xilog(ic)=.true.
            nc=nc+1
            xc(nc)=xnew(ic)
            if (marker.eq.1) then ! on data
               yc(nc)=ynew(ic)
            elseif (marker.eq.2) then ! smooth
               yc(nc)=smooth(npnew,xnew,ynew,ic)
            elseif (marker.eq.3) then ! out of data
               yc(nc)=real(yu)
            endif
            if (nc.ge.2) call SSORT(xc,yc,nc,2) !call sort2(nc,xc,yc)
         endif
      endif
      return
      end

************************************************************************

      subroutine baselinecat(npnew,xnew,ynew,ylimold,datachanged,
     :     file,ileng)          !
      parameter (N=2**14,nmar=4)
      logical choice,datachanged,expert ! choice=1 on data, choice=0 smooth
      character*10 code
      CHARACTER*128 ar
      character*128 file
      integer ileng
      real*8 xu,yu
      real*4 x4,y4,dist,distmin,sigma
      real*4 xnew(*),ynew(*),xc(nmar),yc(nmar),xi(nmar),yb(N)
      integer nc,npnew,ict(nmar)
      common /expert/ expert
      code(1:1)=' '
      sigma=0
      datachanged=.true.
      choice=.true.             ! exact is default
 302  format('INFO : last lim current was ',G12.4)
 301  format('INFO : limiting current is  ',G12.4)
 303  format(A)
 309  format('ERROR : Unknown command ''',A,'''')

      if (ylimold.ne.0.) write(6,302) ylimold
      do i=1,nmar
         xi(i)=0                ! xi(i)=1 if marker #i is set
         xc(i)=100.
         yc(i)=100.
      enddo
      call plot(npnew,xnew,ynew,1) 
      nc=1 
      if (.not.expert) then
         write(6,303) 'First two markers: i=0; last two markers: i=ilim' !
         write(6,303) 'type x,s to get markers eXact or Smooth' !
         write(6,303) 'left button to change the current marker' !
         write(6,303) 'right to NOT change it'
         write(6,303) 'or type 1 to 4 to add the corresponding  marker' !
         write(6,303) 'u to qUit AND save the base line in ''base.dat'''
         write(6,303) 'v to quit replacing data with data/baseline '
         write(6,303) 'mid button or q to quit subtracting '//
     :        'the base line'
      endif 
      do while ((code(1:1).ne.'&').and.
     :     (code(1:1).ne.'Q').and.(code(1:1).ne.'U')
     :     .and.(code(1:1).ne.'V')) ! mid, q or u to quit 
 12      format('Enter marker : ',I1)   
         write(ar,12) nc 
         call gr_exec1('dr text 0 1 "'//ar(1:16)//'" 3 /box 7') 
         if (choice) then       ! say type of marker on upper left corner
            call gr_exec1('dr text 0 -.5 "  (eXact)" 3 /box 7')
         else
            call gr_exec1('dr text 0 -.5 "  (Smooth)" 3 /box 7')
         endif
         call gr_curs(xu,yu,x4,y4,code)
         if ((code(1:1).eq.'1').or.
     :        (code(1:1).eq.'2').or.
     :        (code(1:1).eq.'3').or.
     :        (code(1:1).eq.'4')) then ! add marker
            if (code(1:1).eq.'1') then
               nc=1
            elseif (code(1:1).eq.'2') then
               nc=2
            elseif (code(1:1).eq.'3') then
               nc=3
            elseif (code(1:1).eq.'4') then
               nc=4
            endif
            code(1:1)='^'       ! add marker hereafter
         endif
         if ((choice).and.(code(1:1).eq.'S')) then
            choice=.false.      ! marker set to smooth
         elseif ((.not.choice).and.(code(1:1).eq.'X')) then
            choice=.true.       ! marker set to exact
         elseif (code(1:1).eq.'^') then ! left button, add marker
            xi(nc)=1.
            distmin=100.
            do i=1,npnew
               dist=abs(xu-xnew(i))
               if (dist.le.distmin) then 
                  distmin=dist
                  ict(nc)=i          ! c'est l'indice sur tableau xnew
               endif
            enddo
            xc(nc)=xnew(ict(nc))
            if (choice) then    ! exact
               yc(nc)=ynew(ict(nc))
            else                ! smooth
               yc(nc)=smooth(npnew,xnew,ynew,ict(nc))
            endif
            nc=nc+1
         elseif (code(1:1).eq.'*') then ! next without changing
            nc=nc+1
         elseif ((code(1:1).eq.'&').or.(code(1:1).eq.'Q')
     :           .or.(code(1:1).eq.'U').or.(code(1:1).ne.'V')) then
            continue            ! about to quit
         else
            if (.not.expert) write(6,309) code(1:1)
         endif

         if (nc.eq.5) nc=1

         if ((xi(1)*xi(2)*xi(3)*xi(4)).eq.1) then ! subtract according to dirk
            ict1=ict(1)         ! should check also they are different
            ict2=ict(2)
            ict3=ict(3)
            ict4=ict(4)
            if (ict1.gt.ict2) call swap(ict1,ict2)
            if (ict3.gt.ict4) call swap(ict3,ict4)
            d_s0=reglin2(xnew,ynew,ict1,ict2)
            d_i0=ord2(xnew,ynew,ict1,ict2)
            d_t0=avex(xnew,ynew,ict1,ict2)
            d_sl=reglin2(xnew,ynew,ict3,ict4)
            d_il=ord2(xnew,ynew,ict3,ict4)
            d_tl=avex(xnew,ynew,ict3,ict4)
            d_a=(d_s0-d_sl)/(2.*(d_t0-d_tl))
            d_b=d_s0-2*d_a*d_t0
            d_c=d_i0+d_a*d_t0**2
            ylim=d_il-d_i0+(d_sl-d_s0)*(d_t0+d_tl)/2.
            if (d_t0.le.d_tl) then ! cathodic wave checked
               do i=1,npnew
                  if (xnew(i).le.d_t0) then
                     yb(i)=d_i0+d_s0*xnew(i)
                  elseif (xnew(i).ge.d_tl) then
                     yb(i)=d_il+d_sl*xnew(i)-ylim
                  else
                     yb(i)=d_a*xnew(i)**2+d_b*xnew(i)+d_c
                  endif
               enddo
            else
               do i=1,npnew
                  if (xnew(i).le.d_tl) then
                     yb(i)=d_il+d_sl*xnew(i)-ylim
                  elseif (xnew(i).ge.d_t0) then
                     yb(i)=d_i0+d_s0*xnew(i)
                  else
                     yb(i)=d_a*xnew(i)**2+d_b*xnew(i)+d_c
                  endif
               enddo
            endif
            call plot(npnew,xnew,ynew,1)
            call plotdiff(xnew,yb,ynew,sigma,npnew,.false.) ! plot subtractd data
            call reclim(npnew,xnew,ynew) ! recover limits
            call plot(npnew,xnew,yb,0) ! plot base line
 11         format('cur : ',G10.3,' last : ',G10.3)
            write(ar,11) ylim,ylimold
            call gr_exec1('dr text 0 1 "'//ar(1:34)//'" 2 /box 8') 
         else
            call plot(npnew,xnew,ynew,1)
         endif
         call gr4_give('X',4,xc)
         call gr4_give('Y',4,yc)
         call gr_exec1('poi')   ! plot markers
      enddo  
c     quit
      if ((xi(1)*xi(2)*xi(3)*xi(4)).eq.1) then ! subtract base line
         if (code(1:1).eq.'V') then
            do i=1,npnew
               ynew(i)=ynew(i)/yb(i) ! divide by base line
            enddo
         else ! corrig le 23/11/06
 33         do i=1,npnew
               ynew(i)=ynew(i)-yb(i) ! subtract base line
            enddo
            if ((code(1:1).eq.'U')) then
               open (unit=9,file='base.dat',status='unknown')
               do i=1,npnew
                  write(9,*,err=33) xnew(i),yb(i)
               enddo
               close(9)
               write(6,303) 'INFO : base line saved in ''base.dat'''
            endif
         endif
         write(6,301) ylim
         call writeilimout(file,ileng,ylim)
         ylimold=ylim
      else
         write(6,303) 'INFO : data NOT changed'
         datachanged=.false.
      endif
      return
      end

c     **************************************************

      function smooth(np,x,y,ic) ! according to Dirk, utils
      parameter (N=2**14)
      real*4 x(*),y(*)
      integer np,ic
      integer n1, n2, range
      logical expert
      common /expert/ expert
c      call wait
      range=min(np/10,100)
      n1=ic-range/2
      n2=ic+range/2
      n12=max(1,n1)
      n22=min(np,n2)
      nsrss=np               ! # succ res same sign
      do while((nsrss.gt.(range/4)).and.(n22-n12.gt.6))
         n1=n1+1
         n2=n2-1
         n12=max(1,n1)
         n22=min(np,n2)
c     search number of successive residuals with the same sign
         residualold=0
         nsrss=0
         do i=n12,n22
            residual=y(i)-(ord2(x,y,n12,n22)+
     :           reglin2(x,y,n12,n22)*x(i))
            if ((residualold*residual).gt.0) nsrss=nsrss+1
            residualold=residual
         enddo
c     if number .le. range/4, c'est fini sinon range is decreased.
      enddo
      if (nsrss.lt.range/4) then ! smooth
         smooth=ord2(x,y,n12,n22)+reglin2(x,y,n12,n22)*x(ic) !
cc         slope=reglin2(x,y,n12,n22)
      else
         if ((n12.eq.1).or.(n22.eq.np)) then ! exact
            smooth=y(ic)        
         else                   ! averaged
            smooth=0            
            do i=n12,n22
               smooth=smooth+y(i)/(n22-n12+1) 
            enddo
         endif
cc         slope=reglin2(x,y,1,np)
C 303     format(a)
c         if(expert) write(6,303) 'WARNING in smooth() ' ! too few points to derive accurate smooth marker position'!
      endif
      return
      end
        
        
c     **************************************************

      subroutine swap(i1,i2)
      integer i1,i2,temp
      temp=i1
      i1=i2
      i2=temp
      return
      end

c     **************************************************

      subroutine chooseratio(r1,r2)
      character*4 r1,r2
      integer i, promptforint
 303  format(A)
      write(6,303) '(1) none (2) 1/2 (3) 1/3 (4) 1/4 (5) 1/5 (6) 2/5'
      write(6,303) '(0) to quit without changing ratio'
      write(6,303) 'Choose 5 for Frd (B couple is'//
     :     ' one electron out of 5)' !
      i = promptforint('Your choice (0-6) :','i')
      if (i.eq.0) then
         return
      elseif (i.eq.1) then
         r1(1:4)='*0  '
         r2(1:4)='*1  '
      elseif (i.eq.2) then
         r1(1:4)='*1|2'
         r2(1:4)='*1|2'
      elseif (i.eq.3) then
         r1(1:4)='*1|3'
         r2(1:4)='*2|3'
      elseif (i.eq.4) then
         r1(1:4)='*1|4'
         r2(1:4)='*3|4'
      elseif (i.eq.5) then
         r1(1:4)='*1|5'
         r2(1:4)='*4|5'
      elseif (i.eq.6) then
         r1(1:4)='*2|5'
         r2(1:4)='*3|5'
      endif
      return
      end

c     **************************************************

      subroutine calcxi2(np,x,y,xi2)     
      parameter(N=2**14)
      real x(*),y(*),xi2
      integer np
      xi2=0.
      do i=1,np
         xi2=xi2+y(i)**2
      enddo
      write(6,*) "xi2",xi2
      return
      end

      subroutine dx(np,x,y,mdx)     
      parameter(N=2**14)
      real x(*),y(*),mdx
      integer np
      mdx=0.
      do i=1,np-1
         y(i)=x(i+1)-x(i)
         mdx=mdx+y(i)
      enddo
      np=np-1
      if (np.ne.0) then
         mdx=mdx/real(np)
      else
         mdx=1.
      endif
      return
      end

      subroutine dy(np,x,y)     
      parameter(N=2**14)
      real x(*),y(*)
      integer np
      do i=1,np-1
         y(i)=y(i+1)-y(i)
      enddo
      np=np-1
      return
      end


      subroutine writeilimout(filenameopened,ilengo,ilim)
      character*128 filename, filenameopened
      integer ileng, ilengo
      logical ex
      real*4 ilim
      common /outpeak/ filename, ileng
      inquire(file=filename(1:ileng),exist=ex)
      if (ex) then
         open(unit=9,file=filename(1:ileng),status='old',err=24)
         do i=1,10000
            read(9,*,end=21)
         enddo
 21      continue
         backspace 9
      else
         open(unit=9,file=filename(1:ileng),status='new',err=24)
 303     format(A12,A8)
         write(9,303)' ilim       ','filename'
      endif
 23   format (G12.4,A1,A)
      write(9,23,err=24) ilim,' ',filenameopened(1:ilengo) !
 304  format('INFO : ilim value saved in ',A)
      write(6,304) filename(1:ileng)
      endfile 9
      close(9)
      return
 305  format('ERROR during writing of ',A)
 24   write(6,305) filename(1:ileng)
      return
      end


C     This routine does the actual
      subroutine do_capacitive_subtraction(np, x, y, ytarget,
     :     ru, v, cd)

      parameter (N=2**14,tiny=0.)
c     main
      real*4 x(*),y(*),ytarget(*) 
      integer np                ! The number of points to operate on
      real*4 ru, v, cd          ! The uncompensated resistance, scan speed
                                ! and double-layer capacity
      
      integer i
      
C     We modify the current according to the following formula:
C     
C     i_f = i + cd * dE/dt + ru * cd * di/dt
C
C     This translates to
C
C     i_f = i + cd * sign(deltaE) * v + ru * cd * di/de * sign(deltaE) * v

C     These are very naive derivatives !!!
      do i = 1,np-1
         ytarget(i) = y(i) 

         if(x(i).le.x(i+1)) then
            ytarget(i) = ytarget(i) - v * cd -
     :           v * cd * ru * (y(i+1) - y(i))/(x(i+1) - x(i))
         else
            ytarget(i) = ytarget(i) + v * cd +
     :           v * cd * ru * (y(i+1) - y(i))/(x(i+1) - x(i))
         endif
      enddo

      end
      

C     Prompts the user to choose a baseline for cyclic voltametry
C     experiments.
      subroutine choose_cv_baseline
      parameter (N=2**14)
      
C     The parameters of the baseline
      real*4 baseline_x(n),baseline_y(n)
      real*4 baseline_scale, baseline_const, baseline_slope
      character*128 baseline_buffer_name
      logical baseline_defined
      integer baseline_nps
      
      common /baseline_data/ baseline_x, baseline_y,
     :     baseline_buffer_name, baseline_defined,
     :     baseline_scale, baseline_const, baseline_slope

C     The buffer stack:
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common

      common /stack/ data, nps, filename, ilengname

      integer buf,i

C     The 'bad_buffer' function to check buffer numbers
      logical bad_buffer
      external bad_buffer

      integer promptforint
      external promptforint
      
      call plotbuffers(.true.)  ! hereafter
      buf = promptforint('Buffer to be used as baseline '//
     :     '(1-19, 0 to abort) :','b')
      write(6,*) "Buffer: ", buf

      if ((buf.lt.1).or.(buf.gt.19)) then
 123     format('ERROR: bad buffer ', I2)
         write(6, 123) buf
         return
      endif

      baseline_nps = nps(buf)
      baseline_buffer_name = filename(buf)
      do i=1,baseline_nps
         baseline_x(i) = data(i,buf,1)
         baseline_y(i) = data(i,buf,2)
      enddo
      baseline_defined = .true.
C     Linear deviation
      baseline_slope = 0
      baseline_const = 0
C     Scaling of the original baseline
      baseline_scale = 1

 200  format('Stored buffer ', A, ' for use as baseline')
      write(6, 200) baseline_buffer_name(1:lnblnk(baseline_buffer_name))
     
      end


C     Subtracts the baseline saved in baseline_data to the given curve
      subroutine subtract_baseline(np,x,y)
      parameter (N=2**14,tiny=0.)
      real*4 x(*),y(*),ytarget(N)  ! old to save data (to compute redidue)
      integer np                ! The number of points

C     The parameters of the baseline
      real*4 baseline_x(n),baseline_y(n)
      real*4 baseline_scale, baseline_const, baseline_slope
      character*128 baseline_buffer_name
      logical baseline_defined
      integer baseline_nps
      
      common /baseline_data/ baseline_x, baseline_y,
     :     baseline_buffer_name, baseline_defined,
     :     baseline_scale, baseline_const, baseline_slope

      integer i
      if(.not.baseline_defined) then
 200     format("ERROR: no baseline defined ! (use cb to define one)")
         write(6,200)
         return
      endif

 201  format("INFO: subtracting baseline ", A," from current buffer")
      write(6, 201) baseline_buffer_name(1:lnblnk(baseline_buffer_name))

C     The very-naive-but-efficient-for-a-start way:
      do i=1,n
         y(i) = y(i) - baseline_y(i) * baseline_scale -
     :        baseline_const - baseline_slope * x(i)
      enddo
     
      end

C     Interactively adjust various parameters pertaining to the
C     baseline
C$$$      subroutine adjust_baseline(np,x,y)
C$$$      parameter (N=2**14,tiny=0.)
C$$$      real*4 x(*),y(*),ytarget(N)  ! old to save data (to compute redidue)
C$$$      integer np                ! The number of points

C$$$C     The parameters of the baseline
C$$$      real*4 baseline_x(n),baseline_y(n)
C$$$      character*128 baseline_buffer_name
C$$$      logical baseline_defined
C$$$      integer baseline_nps
      
C$$$      common /baseline_data/ baseline_x, baseline_y,
C$$$     :     baseline_buffer_name, baseline_defined

C$$$      integer i
C$$$      if(.not.baseline_defined) then
C$$$ 200     format("ERROR: no baseline defined ! (use cb to define one)")
C$$$         write(6,200)
C$$$         return
C$$$      endif

C$$$ 201  format("INFO: subtracting baseline ", A," from current buffer")
C$$$      write(6, 201) baseline_buffer_name(1:lnblnk(baseline_buffer_name))

C$$$C     The very-naive-but-efficient-for-a-start way:
C$$$      do i=1,n
C$$$         y(i) = y(i) - baseline_y(i)
C$$$      enddo
     
C$$$      end

C$$$C$$$      subroutine subtract_cv_baseline(np,x,y)

C$$$C$$$      parameter (N=2**14,tiny=0.)
C$$$C$$$c     main
C$$$C$$$      real*4 x(*),y(*),ytarget(N)  ! old to save data (to compute redidue)

C$$$C$$$      character*10 code         ! The user input
C$$$C$$$      integer np                ! The number of points

C$$$C$$$      real*8 promptforfloat
C$$$C$$$      external promptforfloat

C$$$C$$$C     Now, the parameters of the baseline subtraction
C$$$C$$$      real*4 v,cd, ru

C$$$C$$$      common /expert/ expert
C$$$C$$$      logical expert

C$$$C$$$      v = 0.02                  ! Defaults to 20mV/s, because that's what
C$$$C$$$                                ! I'm using
C$$$C$$$      cd = 0
C$$$C$$$      ru = 0

C$$$C$$$      if (.not.expert) then
         
C$$$C$$$         write(6,*) '  r : choose the uncompensated resistance'
C$$$C$$$         write(6,*) '  v : choose the scanning speed'
C$$$C$$$         write(6,*) '  c : choose the double-layer capacity'
C$$$C$$$      endif

C$$$C$$$      do while ((code(1:1).ne.'&').and.
C$$$C$$$     :     (code(1:1).ne.'Q'))  ! mid or q to quit
C$$$C$$$         if(code(1:1).eq.'R') then
C$$$C$$$            ru = promptforfloat("New resistance to be used", "n")
C$$$C$$$         endif
C$$$C$$$         if(code(1:1).eq.'C') then
C$$$C$$$            cd = promptforfloat("New capacity to be used", "n")
C$$$C$$$         endif
C$$$C$$$         if(code(1:1).eq.'V') then
C$$$C$$$            v = promptforfloat("New speed to be used", "n")
C$$$C$$$         endif

C$$$C$$$C     End of stuff...
C$$$C$$$ 201     format('Parameters: v = ', G12.4, ' cd = ', G12.4, ' ru = ',
C$$$C$$$     :        G12.4)
C$$$C$$$         write(6,201) v,cd,ru
C$$$C$$$         call do_capacitive_subtraction(np,x,y,ytarget,ru,v,cd)
C$$$C$$$         call plot(np,x,ytarget)
C$$$C$$$         call gr_curs(xu,yu,x4,y4,code) ! get mouse
C$$$C$$$      enddo                     ! exit if q or mid button.
C$$$C$$$      return
C$$$C$$$      end
      
