C    soas_buff.f: basic buffer manipulations
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

****************************************************************************
c     bhistory list

      subroutine add_to_history(ch,ileng,logstack,logstackl)
      parameter(nlstack=9)
      character*128 ch           ! what to do next ?
      integer*4 ileng
      character*128 logstack(nlstack) ! what's been done before
      integer*4 logstackl(nlstack) ! logstack(i)(1:logstackl(i))
      do i=9,2,-1
         logstack(i)(1:50)=logstack(i-1)(1:50)
         logstackl(i)=logstackl(i-1)
      enddo
      logstack(1)(1:50)=ch(1:50)
      logstackl(1)=ileng      
      return
      end

      subroutine retrieve_from_history(ch,ileng,logstack,logstackl)
      parameter(nlstack=9)
      character*128 ch           ! what to do next ?
      integer*4 ileng
      character*128 logstack(nlstack) ! what's been done before
      integer*4 logstackl(nlstack) ! logstack(i)(1:logstackl(i))
 303  format(A)
      if ((ileng.eq.1).or.(ch(2:2).eq.'1')) then
         ileng=logstackl(1)
         ch(1:50)=logstack(1)(1:50)
      elseif (ileng.eq.2) then
         if (ch(2:2).eq.'!') then
            j=5
         else
            j=ich(ch(2:2),1,1,9)
         endif
         if (logstackl(j).ne.0) then
            ileng=logstackl(j)
            ch(1:50)=logstack(j)(1:50)
            call add_to_history(ch,ileng,logstack,logstackl)
         else
            write(6,303) 'ERROR : No such event.'
            ileng=0
            ch(1:1)=' '
         endif
      endif
      return
      end

      subroutine history(logstack,logstackl)
      parameter(nlstack=9)
      character*128 logstack(nlstack) ! what's been done before
      integer*4 logstackl(nlstack) ! logstack(i)(1:logstackl(i))
 1    format((I1,' : ',A))
      do i=1,9
         if (logstackl(i).ne.0) write(6,1) i, logstack(i)(1:logstackl(i))
      enddo
      return
      end


****************************************************************************
c     buffers


      subroutine changebuffername(name,leng)
      integer leng,lengnew
      character*128 name,namenew, promptfor
C 1    format(a)                 !q,a)
 303  format(A)
 304  format('INFO : buffer name is: ',A,', about to be changed.')
      write(6,304) name(1:leng)
      namenew = promptfor('New name ([abort]) :','n') !write(6,303) 'Enter new name, or return to not change it'
      lengnew=lnblnk(namenew)
      if (lengnew.ne.0) then
            if ((namenew(1:2).eq.'!!').and.(lengnew.ge.2)) then
               name(1:leng+lengnew-2)=name(1:leng)//
     c              namenew(3:lengnew)
               leng=leng+lengnew-2
            else
               leng=lengnew
               name(1:leng)=namenew(1:lengnew)
            endif
      else
         write(6,303) 'INFO : name NOT changed.'
      endif
      return
      end

      subroutine save_stack
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      common /stack/ data, nps, filename, ilengname
      open (unit=1,file='soas.stack',status='unknown')
c 1    format(I)
 2    format(A)
      do i=1,2*nstack-1
         if (nps(i).ne.0) then
            write(1,*) i
            write(1,*) nps(i)
            write(1,*) ilengname(i)
            write(1,2) filename(i)(1:ilengname(i)) !
            do j=1,nps(i)
               write(1,*) data(j,i,1),data(j,i,2)
            enddo
         endif
      enddo
      close(1)
      return
      end

      subroutine load_stack
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      logical ex
      common /stack/ data, nps, filename, ilengname
 303  format(A)
      inquire(file='soas.stack',exist=ex)
      if (ex) then
         do j=1,2*Nstack-1      ! stack of data
            nps(j)=0
            ilengname(j)=0
            filename(j)=''
         enddo
         write(6,303) 'INFO : Loading saved stack...'
         open (unit=1,file='soas.stack',status='old')
         do k=1,2*nstack-1
            read(1,*,end=100,err=100) i
            read(1,*) nps(i)
            if (nps(i).ne.0) then
               read(1,*) ilengname(i)
               read(1,303) filename(i)(1:ilengname(i))
               write(6,303) filename(i)(1:ilengname(i))
               do j=1,nps(i)
                  read(1,*) data(j,i,1),data(j,i,2)
               enddo
            endif
         enddo
 100     close(1)
      else
         write(6,303) 'ERROR : stack not found.'
      endif
      end

C     Vincent Fourmond: adding a routine that pushes the current buffer
C     on the stack, find the first point more than delta after the first
C     point in the buffer, and separate it into two buffers according to
C     this.
      subroutine chop_buffer(delta)
      real delta
C     The stack
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      common /stack/ data, nps, filename, ilengname

C     Local variables
      real start
      integer i,j

      j = 0
C     Now, we find out where is the first point at x = x_0 + delta
      start = data(1,Nstack,1) ! grabbing the first X value
      do i = 2, nps(Nstack)
         if ((j.eq.0).and.((start + delta) .le. data(i,Nstack,1))) then
            j = i - 1
         endif
      enddo

      if(j.eq.0) then
 301     format("WARN: buffer X values don't extend as much as ", 
     :        G12.4, ", not doing anything")
         write(6,301) (delta + start)
C     We abandon here.
         return
      endif
      

      write(6,*) 'Starting at ',j, ' for X = ', data(j,Nstack,1), 
     :     '(from ', start, ')'

C     We save the current buffer two times.
      call un_re_do(0) 
      call un_re_do(0) 

C     We remove the beginning of the cur + 1 one:
      do i = 1, (nps(Nstack) - j)
         data(i,Nstack + 1,1) = data(i + j,Nstack + 1, 1)
         data(i,Nstack + 1,2) = data(i + j,Nstack + 1, 2)
      enddo
      nps(Nstack + 1) = nps(Nstack + 1) - j
      nps(Nstack) = j
      end

      
      subroutine un_re_do(m)    ! see help file for explanations
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      integer m
      logical marked(2*Nstack-1)
      common /stack/ data, nps, filename, ilengname
      common /mark/ marked
 303  format(A)
C 304  format('INFO: Buffer names ',A,' removed from the stack')
      if(m.eq.0) then           ! save 
         do j=2*Nstack-1,Nstack+1,-1
            if (nps(j-1).ne.0) then
               do i=1,nps(j-1)  !Npmax
                  do k=1,nc
                     data(i,j,k)=data(i,j-1,k)
                  enddo
               enddo
            endif
c            if (nps(j).ne.0) write(6,304) filename(j)(1:ilengname(j))
            nps(j)=nps(j-1)
            filename(j)(1:ilengname(j-1))=filename(j-1)(1:ilengname(j-1))
            ilengname(j)=ilengname(j-1)
            marked(j)=marked(j-1)
         enddo
c     hhh
         marked(10)=.false.
      elseif(m.eq.2) then       ! unsave 
         do j=Nstack+1,2*Nstack-1
            if (nps(j).ne.0) then ! au lieu de j-1
               do i=1,nps(j)    ! Npmax
                  do k=1,nc
                     data(i,j-1,k)=data(i,j,k)
                  enddo
               enddo
            endif
            nps(j-1)=nps(j)
            filename(j-1)(1:ilengname(j))=filename(j)(1:ilengname(j))
            ilengname(j-1)=ilengname(j)
            marked(j-1)=marked(j)
         enddo
      elseif (m.eq.1) then      ! undo
         if ((nps(Nstack+1).ne.0)) then
            do j=1,2*Nstack-2
               if (nps(j+1).ne.0) then
                  do i=1,nps(j+1) ! Npmax
                     do k=1,nc
                        data(i,j,k)=data(i,j+1,k)
                     enddo
                  enddo
               endif
               nps(j)=nps(j+1)
               filename(j)(1:ilengname(j+1))=filename(j+1)(1:ilengname(j+1))!
               ilengname(j)=ilengname(j+1)
               marked(j)=marked(j+1)
               nps(j+1)=0       ! hhh
               marked(j+1)=.false.
            enddo
         else
            write(6,303) 'ERROR : No more undo available.'
         endif
      elseif (m.eq.-1) then     ! redo
         if (nps(Nstack-1).ne.0) then
            do j=2*Nstack-1,2,-1
               if (nps(j-1).ne.0) then
                  do i=1,nps(j-1) ! Npmax
                     do k=1,nc
                        data(i,j,k)=data(i,j-1,k)
                     enddo
                  enddo
               endif
               nps(j)=nps(j-1)
               filename(j)(1:ilengname(j-1))=filename(j-1)(1:ilengname(j-1))!
               ilengname(j)=ilengname(j-1)
               marked(j)=marked(j-1)
               nps(j-1)=0       ! hhh
               marked(j-1)=.false.
            enddo
         else
            write(6,303) 'ERROR : No more redo available.'
         endif
      endif
      return
      end

      subroutine switch
      parameter (Npmax=2**14,Nstack=10,nc=2)
      integer promptforint
      real*4 data(Npmax,2*Nstack-1,nc) 
      integer nps(2*Nstack-1)
      character*128 filename(2*Nstack-1)
      integer ilengname(2*Nstack-1)
      common /stack/ data, nps, filename, ilengname
 303  format(A)
      call plotbuffers(.true.)       ! hereafter
      n = promptforint('Buffer number (1-18, 0 to quit) :','b') ! write(6,303) 'Buffer number ? (1-18, 0 to quit)'
      if ((n.ge.1).and.(n.le.18)) then
         if (nps(n).ne.0) then
            call un_re_do(0) ! n becomes n+1 if n.ge.nstack
            if (n.ge.nstack) then
               k2=n+1
            else
               k2=n
            endif
            do i=1,Npmax
               do k=1,nc
                  data(i,NSTACK,k)=data(i,k2,k)
               enddo
            enddo
            nps(NSTACK)=nps(k2)
            filename(NSTACK)=filename(k2)
            ilengname(NSTACK)=ilengname(k2)
         else
 1          FORMAT('ERROR : buffer ',I2,' empty.')
            WRITE(6,1) n 
         endif
      else
         if (n.ne.0) write(6,303) 
     :        'ERROR : try selecting buffer 1 to 18.'
      endif
      return
      end
      
      subroutine overlaybuffer
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) 
      integer nps(2*Nstack-1),np,n
      integer promptforint
      character*128 filename(2*Nstack-1)
      integer ilengname(2*Nstack-1)
      real x(Npmax),y(Npmax)
      logical marked(2*Nstack-1)
      common /stack/ data, nps, filename, ilengname
      common /mark/ marked
 303  format(A)
      call plotbuffers(.true.)       ! hereafter
      n = promptforint('Buffer number (1-18, 0 to quit) :','b') ! write(6,303) 'Buffer number ? (1-18, 0 to quit)'
      if ((n.ge.1).and.(n.le.18)) then
         if (nps(n).ne.0) then
            np=nps(Nstack)
            do i=1,np
               x(i)=data(i,Nstack,1)
               y(i)=data(i,Nstack,2)
            enddo
            marked(n)=.true.
            call plot(np,x,y,10)
            marked(n)=.false.
c$$$            np=nps(Nstack)
c$$$            do i=1,np
c$$$               x(i)=data(i,Nstack,1)
c$$$               y(i)=data(i,Nstack,2)
c$$$            enddo
c$$$            call plot(np,x,y,1)
c$$$            np=nps(n)
c$$$            do i=1,np
c$$$               x(i)=data(i,n,1)
c$$$               y(i)=data(i,n,2)
c$$$            enddo
c$$$            call plot(np,x,y,0)
c$$$ 304        format('INFO : overlaid buffer is ',A)
c$$$            write(6,304) filename(n)(1:ilengname(n))
         else
 1          FORMAT('ERROR : buffer ',I2,' empty.')
            WRITE(6,1) n 
         endif
      else
         if(n.ne.0) write(6,303) 'ERROR : try selecting buffer 1 to 18.'
      endif
      return
      end
      
      subroutine copy(np1,x1,y1,np2,x2,y2) ! copies 2 into 1
      real*4 x1(*),y1(*),x2(*),y2(*)
      integer np2, np1
      np1=np2
      do i=1,np1
         x1(i)=x2(i)
         y1(i)=y2(i)
      enddo
      return
      end

      subroutine plotbuffers(pot)
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! nc=1 (E), 2 (I)
      character*128 file(2*Nstack-1),fifi
      character*2 number
      logical pot,expert
      integer ileng(2*Nstack-1)
      real*4 xt(npmax),yt(npmax)
      integer nps(2*Nstack-1),n
      logical marked(2*Nstack-1)
      logical lastplotstack,showstack
      common /stack/ data, nps, file, ileng
      common /expert/ expert
      common /mark/ marked
      common /lastplot/ lastplotstack
      common /showstack/ showstack
 303  format(a)
      n=0
      do i=1,2*Nstack-1
         n=n+nps(i)
      enddo
      if (n.eq.0) then          ! all buffers empty
         write(6,303) 'ERROR : Load a file first !'
      else
         call gr_exec1('set char .5') ! character size
 1       format(I2)
         call gr_exec('clear')
         do i=1,2*nstack-1      ! loop over buffers
            n=nps(i)              
            if (n.ne.0) then
 304           format(I2,': ',A,', ',I4,' pts.') !
               if(.not.expert) write(6,304) i,file(i)(1:ileng(i)),n
               write(number,1) i ! string ``number'' contains buffer number
               do j=1,npmax
                  if (pot) then
                     xt(j)=data(j,i,1)
                  else
                     xt(j)=real(j)
                  endif
                  yt(j)=data(j,i,2)
               enddo
               call multibox(5,4,i)
               call gr4_give('X',n,xt)
               call gr4_give('Y',n,yt)
               call gr_exec1('lim')
               call gr_box('N N N') 
               if (marked(i).eqv..true.) then
c                  call gr_exec1('pen /col 1') ! red
                  call gr_exec1('dr text .2 -.2 "*"  5 /box 7') !
c                  call gr_exec1('pen /def') ! 
               endif
               if (i.eq.10) call gr_exec1('pen /col 5')
               call gr_conn
               if (i.eq.10) call gr_exec1('pen /col 0')
               if (i.eq.8) then
                  call gr_exec('dr text 0 -.5 "Redo\U2" 5 /box 2')
               elseif (i.eq.9) then
                  call gr_exec('dr text 0 -.5 "Redo" 5 /box 2')
               elseif (i.eq.10) then
                  call gr_exec('dr text 0 -.5 "screeN" 5 /box 2')
               elseif (i.eq.11) then
                  call gr_exec('dr text 0 -.5 "Undo" 5 /box 2')
               elseif (i.eq.12) then
                  call gr_exec('dr text 0 -.5 "Undo\U2" 5 /box 2')
               endif
c     draw buffer name below, and buffer number on left side
               fifi(1:ileng(i))=file(i)(1:ileng(i))
               call gr_exec('dr text 0 .5 "'//fifi(1:ileng(i))//'" 2 /box 8') !
               call gr_exec('dr text -.5 0 "'//number(1:2)//'" 5  /box 4') !
            endif
         enddo
c     if (zarr) then
c     do j=1,nps(Nstack)
c     if (pot) then
c     xt(j)=data(j,Nstack,1)
c     else
c     xt(j)=real(j)
c     endif
c     enddo
c     call multibox(20)
c     call gr4_give('X',nps(Nstack),xt)
c     call gr4_give('Y',nps(Nstack),zarray)
c     call gr_exec1('lim')
c     call gr_box('N N N') 
c     call gr_exec1('dr text 0 -.5 "Z array"  5 /box 2') !
c     call gr_exec1('pen /col 5')
c     call gr_conn
c     call gr_exec1('pen /def')            
c     endif
         call initgreg
         if (showstack) then
            call gr_exec('dr text 0 1.5 "Showing Stack" 1 /box 9')
         endif
      endif
      lastplotstack=.true.
      return
      end

C     Divides the given datafile into segments and average the given
C     fraction into one single value
      subroutine collapse(np, x, y)
      parameter (N=2**14)
      real*4 x(*),y(*)
      integer np, ibeg, iend, i, itarget, nbavg
      logical datachanged
      real*4 target(N)          ! the film loss, since the beginning
      real delta_x              ! the delta_x value for each step
      real first,last           ! the position of the fraction to average

C     Some few external functions
      real*8 promptforfloat
      character*128 promptfor, dummy
      character code
      logical normalize
      

      delta_x = promptforfloat("Delta X for each step: ", "n")
      first =   promptforfloat("Beginning of the fraction", "n")
      last =    promptforfloat("End of the fraction", "n")
      ibeg = 1
      itarget = 1

      call confirm('normalize by the last element',30, normalize,.false.)

C     We loop on all the segments:
      do while(ibeg.lt.np)
C     We scan until the end of the current segment
         iend = ibeg
         do while((iend.le.np).and.(x(iend).lt.(x(ibeg) + delta_x)))
            iend = iend + 1
         enddo

         nbavg = 0
         target(itarget) = 0
         do i=(ibeg + (iend - ibeg)*first),(ibeg + (iend - ibeg)*last)
            target(itarget) =  target(itarget) + y(i)
            nbavg = nbavg + 1
         enddo
         target(itarget) = target(itarget)/nbavg
         itarget = itarget + 1

         ibeg = iend
      enddo

C     Now, feeding data back, normalizing if requested
      np = itarget - 1
      do i = 1,np
         x(i) = i
         y(i) = target(i)
         if(normalize) y(i) = y(i)/target(np)
      enddo

      end
      
