C    soas_cut.f: various buffer operations: cut, subtract, etc.
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

      subroutine cuts(np,x,y,datachanged)
      parameter (N=2**14)
      character*10 code
      character*12 xb,xe
      real*8 xu,yu
      real*4 x4,y4
      real*4 x(*),y(*),xi(N)
      real   delta              ! For autosplit
      integer np, i_begin, i_temp, i_end
      logical datachanged,expert,l_going
      common /expert/ expert
 303  format (A)
 309  format('ERROR : Unknown command ''',A,'''')
 310  format(G12.4)
      do i=1,N
         xi(i)=real(i)
      enddo
      i_begin=1
      i_end=np
      code(1:1)=' '
      call plot(np,xi,y,1)
      write(xb,310) xi(i_begin)
      write(xe,310) xi(i_end)
      call gr_exec1('dr re '//xb//' user_ymin /u')
      call gr_exec1('dr li '//xb//' user_ymax /u')
      call gr_exec1('dr re '//xe//' user_ymin /u')
      call gr_exec1('dr li '//xe//' user_ymax /u')
      if (.not.expert) then
         write(6,303) 'use left/right buttons or b/e for limits' !
         write(6,303) 'use mid button or q to Quit deleting outer range' !
         write(6,303) 'use l/r to put the left/right limit at x ' //
     :        'change of slope'  !
         write(6,303) 'type u qUit deleting inner range'
      endif
      do while((code(1:1).ne.'&').and.(code(1:1).ne.'Q')
     :     .and.(code(1:1).ne.'U')) ! mid button
         call gr_curs(xu,yu,x4,y4,code)
         if ((code(1:1).eq.'^').or.(code(1:1).eq.'B')) then
            i_begin=int(xu)     ! left button
         elseif ((code(1:1).eq.'*').or.(code(1:1).eq.'E')) then
            i_end=int(xu)       ! right button
         elseif((code(1:1).eq.'&').or.(code(1:1).eq.'Q')
     :           .or.(code(1:1).eq.'U')) then !
            continue            ! about to quit
C     Vincent Fourmond: added a way to split data at the 
C     change of slope in x.
         elseif (code(1:1).eq.'R') then !
            if (.not.expert) write (6,303) 
     :           'Taking the right boundary at the discontinuity'
            i_end = i_begin + 1
            l_going = .true. 
            delta = x(2) - x(1)
            do while (l_going.and.(i_end.le.np))
               if ((delta * (x(i_end) - x(i_end - 1))).le.0) then
                  l_going = .false.
                  i_end = i_end - 1
               else
                  i_end = i_end + 1
               endif
            enddo
         elseif (code(1:1).eq.'L') then !
            if (.not.expert) write (6,303) 
     :           'Taking the left boundary at the discontinuity'
            i_begin = i_end - 1
            l_going = .true. 
            delta = x(np - 1) - x(np)
            do while (l_going.and.(i_begin.ge.2))
               if ((delta * (x(i_begin) - x(i_begin + 1))).le.0) then
                  l_going = .false.
                  i_begin = i_begin + 1
               else
                  i_begin = i_begin - 1
               endif
            enddo
         else
            if (.not.expert) write(6,309) code(1:1)
         endif
         if (i_begin.lt.1) i_begin=1
         if (i_end.ge.np) i_end=np
         if (i_begin.eq.i_end) then
            i_begin=1
            i_end=np
         endif
         if (i_begin.gt.i_end) then ! swap begin and end
            i_temp=i_begin
            i_begin=i_end
            i_end=i_temp
         endif
         call plot(np,xi,y,1)
         write(xb,310) xi(i_begin)
         write(xe,310) xi(i_end)
         call gr_exec1('dr re '//xb//' user_ymin /u')
         call gr_exec1('dr li '//xb//' user_ymax /u')
         call gr_exec1('dr re '//xe//' user_ymin /u')
         call gr_exec1('dr li '//xe//' user_ymax /u')
      enddo

      if ((i_begin.eq.1).and.(i_end.eq.np)) then
         datachanged=.false.
         write(6,303) 'WARNING : data not changed'
      else
         datachanged=.true.
          if ((code(1:1).eq.'&').or.(code(1:1).eq.'Q')) then
            np=i_end-i_begin+1
            do i=i_begin,i_end
               x(i-i_begin+1)=x(i) 
               y(i-i_begin+1)=y(i) 
            enddo
c12      format ('INFO : ',I5, ' points left')
ccc        write(6,12) np
            elseif (code(1:1).eq.'U') then
               np=np-(i_end-i_begin)
               do i=i_begin,np
                  x(i)=x(i+i_end-i_begin)
                  y(i)=y(i+i_end-i_begin)
               enddo
            else
               write(6,303) 'WARNING : Should not be here in cuts()'
            endif
      endif
      return
      end

      subroutine subtract(np,x,y,datachanged)
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      integer np, promptforint
      real*4 x(*),y(*)
      logical datachanged,bad_buffer
      common /stack/ data, nps, filename, ilengname
 303  format(A)
      datachanged=.false.
      nps(Nstack)=0
      ilengname(Nstack)=0
      call plotbuffers(1)
      write(6,303) 'I''m going to subtract buffer'//
     :     ' #2 from buffer #1 (i.e. #1-#2)' 
      i1 = promptforint('Buffer #1 is (1-9,11-19) :','b')   
      if (bad_buffer(i1)) return
      if (nps(i1).ne.0) then
 12      format ('INFO : ',I5, ' points in buffer # ',
     :        I2,' from file ',A) ! 
         write(6,12) nps(i1), i1, filename(i1)(1:ilengname(i1)) 
         i2 = promptforint('Buffer #2 is (1-9,11-19) :','b')   
         if ((i2.eq.i1).or.(bad_buffer(i2))) return
         if (nps(i2).ne.0) then
            write(6,12) nps(i2), i2, filename(i2)(1:ilengname(i2)) 
            np=0
            do i=1,nps(i2)
               distmin=100.
               do j=1,nps(i1)
                  dist=abs(data(j,i1,1)-data(i,i2,1))
                  if (dist.le.distmin) then 
                     distmin=dist
                     ii1=j       ! c'est l'indice sur tableau x1
                  endif
               enddo
               if ((ii1.ge.1).and.(ii1.le.nps(i1))) then
                  np=np+1
                  y(np)=data(ii1,i1,2)-data(i,i2,2)
                  x(np)=(data(ii1,i1,1)+data(i,i2,1))/2.
               endif
            enddo

            if(np.ne.0) then
               datachanged=.true.
               if ((filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.ocw').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.OCW').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.dat').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.DAT')) then
                  ilengname(Nstack)=ilengname(i2)-4+ilengname(i1)+1
                  filename(Nstack)(1:ilengname(Nstack))=
     :                 filename(i1)(1:ilengname(i1)-4)//'-'//
     :                 filename(i2)(1:ilengname(i2))
               else
                  ilengname(Nstack)=ilengname(i1)+ilengname(i2)+1
                  filename(Nstack)(1:ilengname(Nstack))=
     :                 filename(i1)(1:ilengname(i1))//'-'//
     :                 filename(i2)(1:ilengname(i2))
               endif
            else
               write(6,303) 'ERROR, data not changed'
            endif
         else
            write(6,303) 'ERROR, buffer #2 empty, data not changed'
         endif
      else
         write(6,303) 'ERROR, buffer #1 empty, data not changed'
      endif
      return
      end
      
C     Divides the first buffer by the second one.
      subroutine divide(np,x,y,datachanged)
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      integer np, promptforint
      real*4 x(*),y(*)
      logical datachanged,bad_buffer
      common /stack/ data, nps, filename, ilengname
 303  format(A)
      datachanged=.false.
      nps(Nstack)=0
      ilengname(Nstack)=0
      call plotbuffers(1)
      write(6,303) 'I''m going to divide buffer'//
     :     ' #1 by buffer #2 (i.e. #1/#2)' 
      i1 = promptforint('Buffer #1 is (1-9,11-19) :','b')   
      if (bad_buffer(i1)) return
      if (nps(i1).ne.0) then
 12      format ('INFO : ',I5, ' points in buffer # ',
     :        I2,' from file ',A) ! 
         write(6,12) nps(i1), i1, filename(i1)(1:ilengname(i1)) 
         i2 = promptforint('Buffer #2 is (1-9,11-19) :','b')   
         if ((i2.eq.i1).or.(bad_buffer(i2))) return
         if (nps(i2).ne.0) then
            write(6,12) nps(i2), i2, filename(i2)(1:ilengname(i2)) 
            np=0
            do i=1,nps(i2)
               distmin=100.
               do j=1,nps(i1)
                  dist=abs(data(j,i1,1)-data(i,i2,1))
                  if (dist.le.distmin) then 
                     distmin=dist
                     ii1=j       ! c'est l'indice sur tableau x1
                  endif
               enddo
               if ((ii1.ge.1).and.(ii1.le.nps(i1))) then
                  np=np+1
                  if(data(i,i2,2).ne.0) then
                     y(np)=data(ii1,i1,2)/data(i,i2,2)
                  else
 350                 format('IGNORING division by 0 at X = ', G4.2)
                     write(6,350) data(i,i2,1)
                     y(np)=0
                  endif
                  x(np)=(data(ii1,i1,1)+data(i,i2,1))/2.
               endif
            enddo

            if(np.ne.0) then
               datachanged=.true.
               if ((filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.ocw').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.OCW').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.dat').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.DAT')) then
                  ilengname(Nstack)=ilengname(i2)-4+ilengname(i1)+1
                  filename(Nstack)(1:ilengname(Nstack))=
     :                 filename(i1)(1:ilengname(i1)-4)//':'//
     :                 filename(i2)(1:ilengname(i2))
               else
                  ilengname(Nstack)=ilengname(i1)+ilengname(i2)+1
                  filename(Nstack)(1:ilengname(Nstack))=
     :                 filename(i1)(1:ilengname(i1))//':'//
     :                 filename(i2)(1:ilengname(i2))
               endif
            else
               write(6,303) 'ERROR, data not changed'
            endif
         else
            write(6,303) 'ERROR, buffer #2 empty, data not changed'
         endif
      else
         write(6,303) 'ERROR, buffer #1 empty, data not changed'
      endif
      return
      end



      subroutine average(np,x,y,datachanged)
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      integer np, promptforint
      real*4 x(*),y(*)
      logical datachanged,bad_buffer
      common /stack/ data, nps, filename, ilengname
 303  format(A)
      datachanged=.false.
      nps(Nstack)=0
      ilengname(Nstack)=0
      call plotbuffers(1)
      write(6,303) 'I''m going to average buffers'//
     :     ' #1 and #2 (i.e. (#1+#2)/2)' 
      i1 = promptforint('Buffer #1 is (1-9,11-19) :','b')   
      if (bad_buffer(i1)) return
      if (nps(i1).ne.0) then
 12      format ('INFO : ',I5, ' points in buffer # ',
     :        I2,' from file ',A) ! 
         write(6,12) nps(i1), i1, filename(i1)(1:ilengname(i1)) 
         i2 = promptforint('Buffer #2 is (1-9,11-19) :','b')   
         if ((i2.eq.i1).or.(bad_buffer(i2))) return
         if (nps(i2).ne.0) then
            write(6,12) nps(i2), i2, filename(i2)(1:ilengname(i2)) 
            np=0
            do i=1,nps(i2)
               distmin=100.
               do j=1,nps(i1)
                  dist=abs(data(j,i1,1)-data(i,i2,1))
                  if (dist.le.distmin) then 
                     distmin=dist
                     ii1=j       ! c'est l'indice sur tableau x1
                  endif
               enddo
               if ((ii1.ne.1).and.(ii1.ne.nps(i1))) then
                  np=np+1
                  y(np)=(data(ii1,i1,2)+data(i,i2,2))/2
                  x(np)=(data(ii1,i1,1)+data(i,i2,1))/2.
               endif
            enddo

            if(np.ne.0) then
               datachanged=.true.
               if ((filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.ocw').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.OCW').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.dat').or.
     :              (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :              .eq.'.DAT')) then
                  ilengname(Nstack)=ilengname(i2)-4+ilengname(i1)+1
                  filename(Nstack)(1:ilengname(Nstack))=
     :                 filename(i1)(1:ilengname(i1)-4)//'+'//
     :                 filename(i2)(1:ilengname(i2))
               else
                  ilengname(Nstack)=ilengname(i1)+ilengname(i2)+1
                  filename(Nstack)(1:ilengname(Nstack))=
     :                 filename(i1)(1:ilengname(i1))//'+'//
     :                 filename(i2)(1:ilengname(i2))
               endif
            else
               write(6,303) 'ERROR, data not changed'
            endif
         else
            write(6,303) 'ERROR, buffer #2 empty, data not changed'
         endif
      else
         write(6,303) 'ERROR, buffer #1 empty, data not changed'
      endif
      return
      end
      
      logical function bad_buffer(i)
      parameter(Nstack=10)
      integer i
c     returns .true. if buffer out of range.
 303  format('ERROR : No such buffer : ', I2)
      bad_buffer=.false.
      if ((i.lt.1).or.(i.eq.Nstack).or.(i.gt.19)) then
         write(6,303) i
         bad_buffer=.true.
      endif
      return
      end

      subroutine insertbuffer(np,x,y,datachanged)
      parameter (Npmax=2**14,Nstack=10,nc=2)
      real*4 data(Npmax,2*Nstack-1,nc) ! common
      integer nps(2*Nstack-1),ilengname(2*Nstack-1) ! common
      character*128 filename(2*Nstack-1) ! common
      integer np, promptforint
      real*4 x(*),y(*)
      logical datachanged,bad_buffer
      common /stack/ data, nps, filename, ilengname
 303  format(A)
      datachanged=.false.
      nps(Nstack)=0
      ilengname(Nstack)=0
c     where is plotbuffer???
      call plotbuffers(0)       ! plot as a function of ``time'', not potential
      write(6,303) 'I''m going to add buffer #2 after buffer #1' !
      i1 = promptforint('Buffer #1 is (1-9,11-19) :','b' )
      if (bad_buffer(i1)) return
      if (nps(i1).ne.0) then
 12      format ('INFO : ',I5, ' points in buffer # ',I2,' named ',A)
         write(6,12) nps(i1), i1, filename(i1)(1:ilengname(i1)) 
         i2 = promptforint('Buffer #2 is (1-9,11-19) :','b' ) 
         if ((i2.eq.i1).or.(bad_buffer(i2))) return
         if (nps(i2).ne.0) then
            if ((nps(i1)+nps(i2)).GT.Npmax) then
               write(6,303) 'ERROR : max number of points exceeded ;'//
     :              ' sorry'    ! 
               return 
            endif 
            write(6,12) nps(i2), i2, filename(i2)(1:ilengname(i2)) 
            np=0
            do i=1,nps(i1)
               np=np+1
               y(np)=data(i,i1,2)
               x(np)=data(i,i1,1)
               nps(Nstack)=np
ccc               data(np,Nstack,3)=np
            enddo
            do i=1,nps(i2)
               np=np+1
               y(np)=data(i,i2,2)
               x(np)=data(i,i2,1)
ccc               data(np,Nstack,3)=np
               nps(Nstack)=np
            enddo
            datachanged=.true.
            if ((filename(i1)(ilengname(i1)-3:ilengname(i1))
     :           .eq.'.ocw').or.
     :           (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :           .eq.'.OCW').or.
     :           (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :           .eq.'.dat').or.
     :           (filename(i1)(ilengname(i1)-3:ilengname(i1))
     :           .eq.'.DAT')) then
               ilengname(Nstack)=ilengname(i1)-4+ilengname(i2)+1
               filename(Nstack)(1:ilengname(Nstack))=
     :              filename(i1)(1:ilengname(i1)-4)//'+'//
     :              filename(i2)(1:ilengname(i2))
            else
               ilengname(Nstack)=ilengname(i2)+ilengname(i1)+1
               filename(Nstack)(1:ilengname(Nstack))=
     :              filename(i1)(1:ilengname(i1))//'+'//
     :              filename(i2)(1:ilengname(i2))
            endif
         else
            write(6,303) 'ERROR, buffer #2 empty, data not changed'
         endif
      else
         write(6,303) 'ERROR, buffer #1 empty, data not changed'
      endif
      return
      end

      subroutine tri(np,x,y)
      parameter (N=2**14)
      real*4 x(*),y(*)
      integer np
      logical forward
      forward=.false.
      if (x(1).lt.x(np)) forward=.true.
      if (forward) then
         call SSORT(X,Y,Np,2) !sort2(np,x,y)
      else
         call SSORT(X,Y,Np,-2)
      endif
      return
      end

      subroutine interpol(np,x,y)
      parameter (N=2**14)
      real*4 x(*),y(*),tempy(N)
      real a,xx,x1,xnp
      integer np,np2
C 201  format(I4)
c 202  format(E4)                !q,E4)
C 203  format(I5)                !q,I5)
C 204  format(A,' limit ',A,'? [',G12.4,']')
C 303  format(A)
C 304  format('WARNING: Max number of points=',I4)
      call tri(np,x,y)
c      write(u,201) np
c 10   call prompt('Number of points ('//u//') ?')
c      read(5,203,err=10) nptemp
c      if (l.ne.0) then
c         np2=nptemp
c         if ((np2.ge.N).or.(np2.le.0)) then 
c            np2=N
c            write(6,304) N 
c         endif
c      else
         np2=np
c      endif
      x1=x(1)
      xnp=x(np)

      do i=1,np2
         xx=x1+(xnp-x1)*real(i-1)/real(np2-1)
         call locate (x,np,xx,j)
         if (j.le.1) then
            tempy(i)=y(1)
         elseif(j.eq.n) then
            tempy(i)=y(n)
         else
            if ((x(j+1)-x(j)).ne.0) then
               a=(x(j+1)-xx)/(x(j+1)-x(j))
               tempy(i)=a*y(j)+(1.-a)*y(j+1)
            else
               tempy(i)=(y(j)+y(j+1))/2. !?
            endif
         endif
      enddo
      do i=1,np2
         y(i)=tempy(i)
         x(i)=x1+(xnp-x1)*real(i-1)/real(np2-1)
      enddo
      np=np2
      return
      end


      subroutine interpolb(np,x,y)
      parameter (N=2**14)
      real*4 x(*),y(*),tempy(N)
      real a,xx,x1,xnp         
      integer np,np2
      call tri(np,x,y)
      np2=500
      x1=-1.
      xnp=-.4
      do i=1,np2
         xx=x1+(xnp-x1)*real(i-1)/real(np2-1)
         call locate (x,np,xx,j)
         if (j.le.1) then
            tempy(i)=-10
         elseif(j.eq.np) then
            tempy(i)=-10
         else
            a=(x(j+1)-xx)/(x(j+1)-x(j))
            tempy(i)=a*y(j)+(1.-a)*y(j+1)
         endif
      enddo
      do i=1,np2
         y(i)=tempy(i)         
         x(i)=x1+(xnp-x1)*real(i-1)/real(np2-1)
      enddo
      np=np2
      return
      end

      subroutine logspacing(np,x,y,datachanged)
      parameter (N=2**14)
      real*4 x(*),y(*)
      real factor,dx
      integer np,np2
      logical datachanged
      call tri(np,x,y)
      factor=1.01
      dx=1.
      np2=1
      np2forward=1
      do while (np2forward+int(dx)*factor.lt.np)
         dx=dx*factor
         np2=np2+1
         np2forward=np2forward+int(dx)
         x(np2)=x(np2forward)
         y(np2)=y(np2forward)
      enddo
      np=np2
      datachanged=.true.
      return
      end

C     truncate the buffer at the first change of sign in delta_x
      subroutine splita(np,x,y)
      real*4 x(*),y(*)
      real init
      integer np,i
      logical finished
      
      init = x(2) - x(1)
      i = 2
      finished = .false.
      do while(.not. finished)
         if((i + 1).ge.np) then
            finished = .true.
            i = np
         endif
         if(init * (x(i+1) - x(i)) .le. 0) then 
            finished = .true.
         else
            i = i + 1
         endif
      enddo
      np = i
      
      end

C     Scans for the first change of sign in delta_x and shifts the
C     x and y data so that
      subroutine splitb(np,x,y)
      real*4 x(*),y(*)
      real init
      integer np,i,j
      logical finished
      
      init = x(2) - x(1)
      i = 2
      finished = .false.
      do while(.not. finished)
         if((i + 1).ge.np) then
            finished = .true.
            i = np
         endif
         if(init * (x(i+1) - x(i)) .le. 0) then 
            finished = .true.
         else
            i = i + 1
         endif
      enddo

C     If we reached the end, we don't do anything
      if(i.eq.np) return
      
      do j = 1,(np - i)
         x(j) = x(i+j)
         y(j) = y(i+j)
      enddo

      np = np - i
      
      end

C     Whether the given data is monotonic.
      function is_monotonic(np,x,y)
      integer np, itmp
      real*4 x(*),y(*)
      logical is_monotonic
      
      itmp = np
      call splita(itmp, x, y)
      if (itmp.lt.np) then
         is_monotonic = .false.
      else
         is_monotonic = .true.
      endif
      end



C     This rountine prompts the user for selecting a region
C     If the data provided here is not monotonous, expect
C     dreadful performance !!
      subroutine choose_region(np,x,y,prompt, i_begin, i_end)
      parameter (N=2**14)
      character*10 code
      character*128 prompt
      character*16 xb,xe
      real*8 xu,yu
      real*4 x4,y4
      real*4 x(*),y(*)
      real delta                ! for finding the closest point...
      real sign                 ! does x increase with i or not ?
      integer np, i_begin, i_temp, i_end, length
      logical expert, notfound
      common /expert/ expert
 303  format (A)
 309  format('ERROR : Unknown command ''',A,'''')
 310  format(G12.4)
      i_begin=1
      i_end=np
      code(1:1)=' '
      sign = x(2) - x(1)
      length = lnblnk(prompt)
      call plot(np,x,y,1)
      write(xb,310) x(i_begin)
      write(xe,310) x(i_end)
      call gr_exec1('dr re '//xb//' user_ymin /u')
      call gr_exec1('dr li '//xb//' user_ymax /u')
      call gr_exec1('dr re '//xe//' user_ymin /u')
      call gr_exec1('dr li '//xe//' user_ymax /u')
      write(6, 303) prompt(1:length)
      if (.not.expert) then
         write(6 303) 'use left/right buttons or b/e for limits' !
         write(6,303) 'use mid button or q to accept the current values' !
      endif
      do while((code(1:1).ne.'&').and.(code(1:1).ne.'Q')) ! right button + Q
         call gr_curs(xu,yu,x4,y4,code)
         if (((sign.ge.0).and.
     :        ((code(1:1).eq.'^').or.(code(1:1).eq.'B')))
     :        .or.
     :        ((sign.le.0).and.
     :        ((code(1:1).eq.'*').or.(code(1:1).eq.'E')))) then
            notfound = .true.
            delta = x(1) - xu
            if((delta * sign).ge.0) then
               i_begin = 1
            else
               i_begin = 2
               do while((i_begin.le.np).and.
     :              ((delta * (x(i_begin) - xu)).ge.0))
                  delta = x(i_begin) - xu
                  i_begin = i_begin+1
               enddo
            endif
         elseif (((sign.le.0).and.
     :        ((code(1:1).eq.'^').or.(code(1:1).eq.'B')))
     :        .or.
     :        ((sign.ge.0).and.
     :        ((code(1:1).eq.'*').or.(code(1:1).eq.'E')))) then
            delta = x(np) - xu
            if((delta * sign).le.0) then
               i_end = np
            else
               i_end = np - 1
               do while((i_end.ge.1).and.
     :              ((delta * (x(i_end) - xu)).ge.0))
                  delta = x(i_end) - xu
                  i_end = i_end-1
               enddo
            endif
         elseif((code(1:1).eq.'&').or.(code(1:1).eq.'Q')
     :           .or.(code(1:1).eq.'U')) then !
C     Nothing to do, but we maek sure the sanitizing code is run
         else
            if (.not.expert) write(6,309) code(1:1)
         endif
         if (i_begin.lt.1) i_begin=1
         if (i_end.ge.np) i_end=np
         if (i_begin.eq.i_end) then
            i_begin=1
            i_end=np
         endif
         if (i_begin.gt.i_end) then ! swap begin and end
            i_temp=i_begin
            i_begin=i_end
            i_end=i_temp
         endif
         call plot(np,x,y,1)
         write(xb,310) x(i_begin)
         write(xe,310) x(i_end)
         call gr_exec1('dr re '//xb//' user_ymin /u')
         call gr_exec1('dr li '//xb//' user_ymax /u')
         call gr_exec1('dr re '//xe//' user_ymin /u')
         call gr_exec1('dr li '//xe//' user_ymax /u')
      enddo
      end
