C     soas_double_layer.f: double-layers baselines subtractions
C     Copyright (C) 1999-2008  Christophe Leger
C                   2007, 2008 Vincent Fourmond
C
C     This program is free software; you can redistribute it and/or
C     modify it under the terms of the GNU General Public License as
C     published by the Free Software Foundation; either version 2 of the
C     License, or (at your option) any later version.
C
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
C     General Public License for more details.
C
C     You should have received a copy of the GNU General Public License
C     along with this program; if not, write to the Free Software
C     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
C     02110-1301 USA.


C     This routine handles all the commands starting with 'dl_'
      subroutine dl_do(N,X,Y,name,leng,fitfcn,lfitfcn,
     :     datachanged)

      parameter (MAXN=2**14)
      integer npin,lfitfcn
      character*128 name,oname   ! o for output (fitres)
      integer leng,oleng        ! o for output
      character*128 fitfcn,fcnname
      character*200 promptfor  ! for arbitrary fits.
      character*300 tmpstring
      real*8 promptforfloat
      logical datachanged,conf,forceraw,expert,success,notdone

C     Function from soas_cut.f:
      logical is_monotonic

C  PARAMETER DECLARATIONS AND SPECIFICATIONS
      integer    ldifx,ldscld,ldstpd,ldwd,ldwe,ldx,ldy,ld2wd,ld2we,
     +     liwork,lwork,maxm,maxnp,maxnq !,maxn
      parameter (maxm=1,maxnp=28,maxnq=1, !,maxn already set to 2**14
     +     ldy=maxn,ldx=maxn,
     +     ldwe=1,ld2we=1,ldwd=1,ld2wd=1,
     +     ldifx=maxn,ldstpd=1,ldscld=1,
     +     lwork=18 + 11*maxnp + maxnp**2 + maxm + maxm**2 + 
     +     4*maxn*maxnq + 6*maxn*maxm + 2*maxn*maxnq*maxnp +  
     +     2*maxn*maxnq*maxm + maxnq**2 + 
     +     5*maxnq + maxnq*(maxnp+maxm) + ldwe*ld2we*maxnq,
     +     liwork=20+maxnp+maxnq*(maxnp+maxm))


c  variable declarations 
      integer i,info,iprint,j,job,l,lunerr,lunrpt,m,maxit,n,
     +     ndigit,np,nq
      integer ifixb(maxnp),ifixx(ldifx,maxm),iwork(liwork)
      real partol,sstol,taufac
      real beta(maxnp),sclb(maxnp),scld(ldscld,maxm),
     +     stpb(maxnp),stpd(ldstpd,maxm),
     +     wd(ldwd,ld2wd,maxm),we(ldwe,ld2we,maxnq),
     +     work(lwork),x(ldx,maxm),y(ldy,maxnq),
     :     y2(ldy,maxnq)

C     For the trimmed-down data
      real x_trimmed(ldx,maxm), y_trimmed(ldy,maxnq)
c  [christophe:] for calls to winf, see page 83 ordpack_guide.ps
      logical          isodr 
      integer          deltai,epsi,xplusi,fni,sdi,vcvi, 
     +                 rvari,wssi,wssdei,wssepi,rcondi,etai,
     +                 olmavi,taui,alphai,actrsi,pnormi,rnorsi,prersi,
     +                 partli,sstoli,taufci,epsmai,
     +                 beta0i,betaci,betasi,betani,si,ssi,ssfi,qrauxi,ui,!
     +                 fsi,fjacbi,we1i,diffi,
     +                 deltsi,deltni,ti,tti,omegai,fjacdi,
     +                 wrk1i,wrk2i,wrk3i,wrk4i,wrk5i,wrk6i,wrk7i,
     +                 lwkmn
c     to put the covariance matrix, but weird...
      real             vcv(maxnp,maxnp)
      real             variance(maxnp)
      real             vcv2(maxnp,maxnp)
c     to allow direct calls to fcn
      real             fjacb,fjacd ! (dummy calls to fcn)
      integer          istop

C     Parameters for gr_curs:
      real*8 xu,yu
      real*4 x4,y4
      character code

      character*1 ch
      real temp,fara            ! temperature (from common), faraday constant
      character*128 parametername(MAXNP) ! names of the parameters
      real xx,yy                ! dummy
      real x_start, x_end       ! to save the X starting end ending points
      real tmp1, tmp2           ! temporary variables
      integer tmpi              ! temporary integer
      common /temperature/ temp
      common /ishape_wc/ ISHAPE
      common /job/ JOB,IPRINT   ! for changing parameters
      common /expert/ expert
C     If the common variable autoout is true, then a summary of the
C     parameters from each fit is written to the output file.
      logical autoout, askout
      common /autooutput/ autoout, askout
C     We use a storage place for the parameters
C     2: one for the downwards scan, one for the upwards scan
      real old_parameters(maxnp,2)
      common /dl_parameters/ old_parameters
      integer direction         ! 1 for downwards, 2 for upwards.

C     dl_*-specific parameters
      integer itmp, i_beg, i_end, i_total
      integer i_sep             ! to say when we switch from 0 to constant
C     Temporary storage place for fits with partial data sets
      real x_part(maxn), y_part(maxn)
      external fcn_double_layer_power_plus_const
      external fcn_double_layer_exp_plus_const

      fara=96500./8.3144/temp

      


C  SPECIFY DEFAULT VALUES FOR SODRC ARGUMENTS
      WE(1,1,1)  = -1.0E0
      WD(1,1,1)  = -1.0E0
c     IFIXB(1)   = -1
      IFIXX(1,1) = -1
      JOB        = -1
      NDIGIT     = -1
      TAUFAC     = -1.0E0
      SSTOL      = -1.0E0
      PARTOL     = -1.0E0
      MAXIT      = -1
c     IPRINT     = -1
      LUNERR     = -1
      LUNRPT     = -1
      STPB(1)    = -1.0E0
      STPD(1,1)  = -1.0E0
      SCLB(1)    = -1.0E0
      SCLD(1,1)  = -1.0E0
c
      M          = 1
      NQ         = 1
      IPRINT     = 0            ! new default = no info, can be modif by user
      x_start    = x(1,1)
      x_end      = x(n,1)

      do i=1,MAXNP
         ifixb(i)=1             ! default for now = all parameters are free
      enddo

C     Fits a pure capacitive current.
      if (fitfcn(1:lfitfcn).eq.'fit') then
         if(.not.(is_monotonic(n,x,y))) then
            write(6, *) "ERROR: x values should "//
     :           "be monotonous (use splita/b)"
            return
         endif
C     We now want to fit.
         if (x(1,1).ge.x(2,1)) then
            direction = 1
         else
            direction = 2
         endif

C     estimate_double_layer_exp_parameters
         call setup_double_layer_exp(np, parametername)
         call confirm('use old parameters',18,conf,.false.)
         if(conf) then
            do i=1,maxnp
               beta(i) = old_parameters(i, direction)
            enddo
         else
            call estimate_double_layer_exp_parameters(beta, x, y, n)
         endif
C     In any case, we setup the xstart and xend parameters:
         ifixb(7) = 0
         beta(7) = x(1,1)

         ifixb(8) = 0
         beta(8) = x(n,1)

C     Now, we have an initial guess, display it !
         call plot(n,x,y,1)    ! the curve

C     Switching to evaluation mode ???
         ideval=3
         call fcn_double_layer_exp(n,m,np,nq,n,m,np,beta,x,
     +        ifixb,ifixx,ldifx,ideval,y2,fjacb,fjacd,istop)
         call plot(n,x,y2,0)    ! the initial guess
         call modifyparamodr(beta,ifixb,np,parametername)
         call fcn_double_layer_exp(n,m,np,nq,n,m,np,beta,x,
     +        ifixb,ifixx,ldifx,ideval,y2,fjacb,fjacd,istop)
         call plot(n,x,y2,0)    ! the initial guess
         call confirm('fit',3,conf,.true.)
         if(conf) then
C     First, we fit
            call sodrc(fcn_double_layer_exp,
     +           n,m,np,nq,beta,y,ldy,x,ldx,we,ldwe,ld2we,wd,ldwd,ld2wd,
     +           ifixb,ifixx,ldifx,job,ndigit,taufac,sstol,partol,maxit,
     +           iprint,lunerr,lunrpt,stpb,stpd,ldstpd,sclb,scld,
     +           ldscld,work,lwork,iwork,liwork,info)
C     Then, we collect various information
            call swinf(n,m,np,nq,ldwe,ld2we,isodr, 
     :           deltai,epsi,xplusi,fni,sdi,vcvi,
     :           rvari,wssi,wssdei,wssepi,rcondi,etai,
     :           olmavi,taui,alphai,actrsi,pnormi,rnorsi,prersi,
     :           partli,sstoli,taufci,epsmai,
     :           beta0i,betaci,betasi,betani,si,ssi,ssfi,qrauxi,ui,
     :           fsi,fjacbi,we1i,diffi,
     :           deltsi,deltni,ti,tti,omegai,fjacdi,
     :           wrk1i,wrk2i,wrk3i,wrk4i,wrk5i,wrk6i,wrk7i,
     :           lwkmn)
c     final estimate = best fit
            do i=1,n
               y2(i,1)=work(fni-1+i)
            enddo

            call uputs("")
            write(6,*) 'Sum of squares,', work(wssi)

C     Getting the covariance matrix
            do i=1,np
               do j=1,np
                  vcv(i,j)=work(vcvi-1+I+(J-1)*NP)*work(rvari)
               enddo
            enddo

            call plot(N,X,Y,1)  ! raw data
            call plot(N,X,Y2,0) ! fit overlaid
            call plotdiff(x,y,y2,0.,N,.false.) ! residue
            conf = .false.
            call writeparamodr(beta,np,parametername,
     :           10,name,6,.true.)
            write(6,*) ""
            call confirm('keep the parameters for later use',33,
     :           conf, .true.)
            if(conf) then
               do i=1,maxnp
                  old_parameters(i, direction)=beta(i)
               enddo
            endif

            return
         else
            write(6, *) "Not fitting at the users request"
            return 
         endif

C     Makes a baseline
      elseif (fitfcn(1:lfitfcn).eq.'make') then

         if(.not.(is_monotonic(n,x,y))) then
            write(6, *) "ERROR: x values should "//
     :           "be monotonous (use splita/b)"
            return
         endif

         if (x(1,1).ge.x(2,1)) then
            direction = 1
         else
            direction = 2
         endif

C     We want to synthesize a baseline.
         call setup_double_layer_exp(np, parametername)
         write(6, *) 'Using old parameters'
         do i=1,maxnp
            beta(i) = old_parameters(i,direction)
         enddo

         notdone = .true.
         do while(notdone)
            call fcn_double_layer_exp(n,m,np,nq,n,m,np,beta,x,
     +           ifixb,ifixx,ldifx,3,y2,fjacb,fjacd,istop)
            call plot(N,X,Y,1)  ! raw data
            call plot(N,X,Y2,0) ! fit overlaid
            call plotdiff(x,y2,y,0.,N,.false.) ! residue

 400        format("(", A1, "): modify ", A, "(", G12.4, ")")
            do i = 1, np
               j = lnblnk(parametername(i))
               write(6, 400) char(ichar('0') + i - 1),
     :              parametername(i)(1:j), beta(i)
            enddo
            write(6, *) "(F): fit with constraints"
            write(6, *) "(U): subtract baseline from buffer"
            write(6, *) "(R): replace buffer with baseline"
            write(6, *) "(S): save parameters for next time"
            write(6, *) "(W): write parameters to the output file"
            write(6, *) "(Q): finish, not doing anything"
            call gr_curs(xu,yu,x4,y4,code) ! get mouse + keyboard events
            if(code.eq.'Q') then
               notdone = .false.
            elseif(code.eq.'S') then
               do i=1,maxnp
                  old_parameters(i, direction) = beta(i)
               enddo
               write(6, *) "Parameters saved"
            elseif(code.eq.'W') then
               write(tmpstring, *) (beta(j), j=1,np), direction
               call write_output_line(tmpstring, lnblnk(tmpstring))
               write(6, *) "Parameters saved to the output file"
            elseif(code.eq.'U') then
               do i=1,n
                  y(i,1) = y(i,1) - y2(i,1)
               enddo
               datachanged = .true.
               return
            elseif(code.eq.'R') then
               do i=1,n
                  y(i,1) = y2(i,1)
               enddo
               datachanged = .true.
               return
            elseif((ichar(code).ge.ichar('0')).and.
     :              ichar(code).lt.(ichar('0')+np)) then
               i = ichar(code) - ichar('0') + 1
               j = lnblnk(parametername(i))
 410           format("Value for ", A," (old value ", G12.4, "):") 
               write(name, 410) parametername(i)(1:j), beta(i)
               beta(i) = promptforfloat(name, "n")
C     We try to fit over a given region
            elseif(code.eq.'F') then 
C     We now need to choose two regions:
C     * a region where we expect the resulting current to be 0
C     * a region where we expect it to be constant

               write(name, *) "Choose a region that should "//
     :              "collapse to 0"
               call choose_region(n, x, y, name, i_beg, i_end)
               do i = i_beg,i_end
                  x_part(i - i_beg + 1) = x(i,1)
                  y_part(i - i_beg + 1) = y(i,1)
               enddo
               i_sep = i_end-i_beg+1 ! The last element for which we

               write(name, *) "Choose a region that should "//
     :              "be constant"
               call choose_region(n, x, y, name, i_beg, i_end)
               do i = i_beg,i_end
                  x_part(i - i_beg + 1 + i_sep) = x(i,1)
                  y_part(i - i_beg + 1 + i_sep) = y(i,1)
               enddo
               i_total = i_sep + (i_end - i_beg + 1)
C     Now, we are ready to fit.
               np = np + 2
               parametername(np-1) = 'constant'
               beta(np-1) = y(i_end,1) - y2(i_end,1)
               parametername(np) = 'switch'
               beta(np) = real(i_sep)
               ifixb(np) = 0

C     By default, we disable few parameters: neither E0 nor the order
C     should move:
C               ifixb(7) = 0
C               ifixb(6) = 0
     
C     Now, we have an initial guess, display it !
               call plot(n,x,y,1) ! the curve

C     Switching to evaluation mode ???
               ideval=3
               call fcn_double_layer_exp(n,m,np,nq,n,m,np,beta,x,
     +              ifixb,ifixx,ldifx,3,y2,fjacb,fjacd,istop)
               call plot(n,x,y2,0) ! the initial guess
               call modifyparamodr(beta,ifixb,np,parametername)
               write(6,*) "Plotting raw data"
               call fcn_double_layer_exp_plus_const(i_total,m,np,
     :              nq,i_total,m,
     :              np,beta,x_part,
     +              ifixb,ifixx,ldifx,3,y2,fjacb,fjacd,istop)
               call plot(i_total,x_part,y_part,1) 
               call plot(i_total,x_part,y2,0) ! the initial guess
               call confirm('fit',3,conf,.true.)
               if(conf) then
C     First, we fit
                  call sodrc(fcn_double_layer_exp_plus_const,
     +                 i_total,m,np,nq,beta,y_part,ldy,x_part,ldx,we,
     :                 ldwe,ld2we,wd,ldwd,ld2wd,
     +                 ifixb,ifixx,ldifx,job,ndigit,taufac,sstol,
     :                 partol,maxit,
     +                 iprint,lunerr,lunrpt,stpb,stpd,ldstpd,sclb,scld,
     +                 ldscld,work,lwork,iwork,liwork,info)
C     Then, we collect various information
                  call swinf(i_total,m,np,nq,ldwe,ld2we,isodr, 
     :                 deltai,epsi,xplusi,fni,sdi,vcvi,
     :                 rvari,wssi,wssdei,wssepi,rcondi,etai,
     :                 olmavi,taui,alphai,actrsi,pnormi,rnorsi,prersi,
     :                 partli,sstoli,taufci,epsmai,
     :                 beta0i,betaci,betasi,betani,si,ssi,ssfi,qrauxi,
     :                 ui, fsi,fjacbi,we1i,diffi,
     :                 deltsi,deltni,ti,tti,omegai,fjacdi,
     :                 wrk1i,wrk2i,wrk3i,wrk4i,wrk5i,wrk6i,wrk7i,
     :                 lwkmn)

                  write(6,*) 'Sum of squares,', work(wssi)

C     Getting the covariance matrix
                  do i=1,np
                     do j=1,np
                        vcv(i,j)=work(vcvi-1+I+(J-1)*NP)*work(rvari)
                     enddo
                  enddo
                  
                  call plot(N,X,Y,1) ! raw data

C     What was actually fit:
                  do i=1,i_total
                     y2(i,1)=work(fni-1+i)
                  enddo
                  call plot(i_total,X_part,Y2,2) ! fit overlaid

C     Baseline
                  call fcn_double_layer_exp(n,m,np,nq,n,m,np,beta,x,
     +                 ifixb,ifixx,ldifx,3,y2,fjacb,fjacd,istop)
                  call plot(N,X,Y2,0) ! fit overlaid


                  call plotdiff(x,y,y2,0.,N,.false.) ! residue
                  conf = .false.
                  call writeparamodr(beta,np,parametername,
     :                 10,name,6,.true.)
                  np = np - 2
               endif
            endif
         enddo
      else
C     UNRECOGNIZED FUNCTION
 304     format('ERROR: unkown double-layer command: ', A,
     :        '. Use commands to know the full list.' )                 !
         write(6,304) fitfcn(1:lfitfcn)
         return
      endif
      end

      subroutine setup_double_layer_power(np, parametername)
      integer np
      parameter (maxnp=28)
      character*128 parametername(maxnp) ! names of the parameters
      np=7
      parametername(1)='i0'     ! average current = C * V ?
      parametername(2)='a'      ! linear slope = R ??
      parametername(3)='ampl'   ! amplitude of the initial exponential phase
      parametername(4)='v0'     ! length of the initial exponential phase
      parametername(5)='a2'     ! amplitude of the power phase
      parametername(6)='E0'     ! start of the power phase, counted from
                                ! the first point
      parametername(7)='alpha'  ! exponent of the power phase
      end

      subroutine setup_double_layer_exp(np, parametername)
      integer np
      parameter (maxnp=28)
      character*128 parametername(maxnp) ! names of the parameters
      np=8
      parametername(1)='i0'     ! average current = C * V ?
      parametername(2)='a'      ! linear slope = R ??
      parametername(3)='ampl'   ! amplitude of the initial exponential phase
      parametername(4)='v0'     ! length of the initial exponential phase
      parametername(5)='a2'     ! amplitude of the growing exponential phase,
                                ! with respect to the end of the graph
      parametername(6)='v1'     ! voltage scale of the growing
                                ! exponential phase
      parametername(7)='xstart' ! the voltage at the start of the baseline
                                ! should not be adjusted.
      parametername(8)='xend'   ! the voltage at the end of the baseline
                                ! should not be adjusted.
      end


      subroutine estimate_double_layer_power_parameters(beta, x, y, n)
      integer n
      parameter (maxn=2**14, maxnp=28)
      real beta(maxnp),x(maxn,1),y(maxn,1)
C     We skip the first and last elements of the baseline for
C     linear regression estimation
      beta(1) = ord2(x,y,n/5,4*n/5)
      beta(2) = reglin2(x,y,n/5,4*n/5)
      beta(3) = y(1,1) - beta(1)- beta(2) * x(1,1)
      
      beta(4) = abs(x(1,1) - x(N,1))/20
      beta(6) = abs(x(1,1) - x(N,1))*2/3
      beta(7) = 3
      
C     Important note: the sign of the amplitude should be right
C     else it won't fit.
      beta(5) = (y(N,1) - beta(1) - beta(2) * x(N,1)) /
     :     (abs(x(N,1) - x(1,1)) - beta(6))**beta(7)
      beta(7) = x(1,1)
      end

      subroutine estimate_double_layer_exp_parameters(beta, x, y, n)
      integer n
      parameter (maxn=2**14, maxnp=28)
      real beta(maxnp),x(maxn,1),y(maxn,1)
C     We skip the first and last elements of the baseline for
C     linear regression estimation
      beta(1) = ord2(x,y,n/5,4*n/5)
      beta(2) = reglin2(x,y,n/5,4*n/5)
      beta(3) = y(1,1) - beta(1)- beta(2) * x(1,1)
      
      beta(4) = abs(x(1,1) - x(N,1))/20
      beta(6) = abs(x(1,1) - x(N,1))/10
      
C     Important note: the sign of the amplitude should be right
C     else it won't fit.
      beta(5) = (y(N,1) - beta(1) - beta(2) * x(N,1))
C /     :     (exp(abs(x(N,1) - x(1,1))/beta(6)))
      end


      subroutine fcn_double_layer_power(n,m,np,nq,
     +     ldn,ldm,ldnp,
     +     beta,xplusd,
     +     ifixb,ifixx,ldifx,
     +     ideval,f,fjacb,fjacd,
     +     istop)
      integer          i,ideval,istop,l,ldifx,ldm,ldn,ldnp,m,n,np,nq
      real             beta(np),xplusd(ldn,m)
      integer          ifixb(np),ifixx(ldifx,m)
      real             f(ldn,nq),fjacb(ldn,ldnp,nq),fjacd(ldn,ldm,nq)
      real             x_from_start
      istop=0
c     compute function
      
      if (mod(ideval,10).ge.1) then
         do i = 1,n         ! n points
c     the distance from the start of the voltammogram
            x_from_start = abs(xplusd(1,1)-xplusd(i,1))
            f(i,1)= beta(1) + beta(2)*xplusd(i,1) +
     :           beta(3)*exp(-x_from_start/beta(4))
            if (x_from_start.ge.beta(6)) then
               f(i,1) = f(i,1) + beta(5) *
     :              (x_from_start - beta(6))**beta(7)
            endif
         enddo
      end if
      return
      end



      subroutine fcn_double_layer_power_plus_const(n,m,np,nq,
     +     ldn,ldm,ldnp,
     +     beta,xplusd,
     +     ifixb,ifixx,ldifx,
     +     ideval,f,fjacb,fjacd,
     +     istop)
      integer          i,ideval,istop,l,ldifx,ldm,ldn,ldnp,m,n,np,nq
      real             beta(np),xplusd(ldn,m)
      integer          ifixb(np),ifixx(ldifx,m)
      real             f(ldn,nq),fjacb(ldn,ldnp,nq),fjacd(ldn,ldm,nq)
      real             x_from_start
      istop=0
c     compute function

C     First, use the standard double_layer_power model
      call fcn_double_layer_power(n,m,np,nq,
     +     ldn,ldm,ldnp,
     +     beta,xplusd,
     +     ifixb,ifixx,ldifx,
     +     ideval,f,fjacb,fjacd,
     +     istop)

C     Then, we add a constant
      if (mod(ideval,10).ge.1) then
         do i = int(beta(9) + 1),n         ! n points
            f(i,1)= beta(8) + f(i,1)
         enddo
      end if
      end

      subroutine fcn_double_layer_exp(n,m,np,nq,
     +     ldn,ldm,ldnp,
     +     beta,xplusd,
     +     ifixb,ifixx,ldifx,
     +     ideval,f,fjacb,fjacd,
     +     istop)
      integer          i,ideval,istop,l,ldifx,ldm,ldn,ldnp,m,n,np,nq
      real             beta(np),xplusd(ldn,m)
      integer          ifixb(np),ifixx(ldifx,m)
      real             f(ldn,nq),fjacb(ldn,ldnp,nq),fjacd(ldn,ldm,nq)
      real             x_from_start, x_to_end
      istop=0
c     compute function
      
      if (mod(ideval,10).ge.1) then
         do i = 1,n         ! n points
c     the distance from the start of the voltammogram
            x_from_start = abs(beta(7)-xplusd(i,1))
            x_to_end =     abs(beta(8)-xplusd(i,1))
            f(i,1)= beta(1) + beta(2)*xplusd(i,1) +
     :           beta(3) * exp(-x_from_start/beta(4)) +
     :           beta(5) * exp(-x_to_end/beta(6))
         enddo
      end if
      return
      end


      subroutine fcn_double_layer_exp_plus_const(n,m,np,nq,
     +     ldn,ldm,ldnp,
     +     beta,xplusd,
     +     ifixb,ifixx,ldifx,
     +     ideval,f,fjacb,fjacd,
     +     istop)
      integer          i,ideval,istop,l,ldifx,ldm,ldn,ldnp,m,n,np,nq
      real             beta(np),xplusd(ldn,m)
      integer          ifixb(np),ifixx(ldifx,m)
      real             f(ldn,nq),fjacb(ldn,ldnp,nq),fjacd(ldn,ldm,nq)
      istop=0
c     compute function

C     First, use the standard double_layer_power model
      call fcn_double_layer_exp(n,m,np,nq,
     +     ldn,ldm,ldnp,
     +     beta,xplusd,
     +     ifixb,ifixx,ldifx,
     +     ideval,f,fjacb,fjacd,
     +     istop)

C     Then, we add a constant
      if (mod(ideval,10).ge.1) then
         do i = int(beta(np) + 1),n         ! n points
            f(i,1)= beta(np-1) + f(i,1)
         enddo
      end if
      end


C     TODO: now, write a routine to ANNOTATE a curve with a given number.
C     Say, default is 0, and you can select a region to annotate it with
C     a given value (corresponding to a string ???).
C     
C     Have that stored in an array of integers.
C
C     Then, use a common with an evaluation function to see in which
C     parts a constant should be used, and in which parts not.
C     
C     Or something simpler ??? But that isn't the most difficult thing
C     to do...
C
C     Use points and a given color for each selected stuff, that will
C     be much easier ;-)...
      

C     This routine is mostly useless for now...
      subroutine select_annotated(nb, x, y, annotations,
     :     chosen_annotation,
     :     target_x, target_y, target_nb)
      parameter (maxn=2**14)
      integer nb, target_nb, chosen_annotation, annotations(maxn)
      real x(maxn), y(maxn), target_x(maxn), target_y(maxn)

C     Temporary variables
      integer i
      
      target_nb = 0
      do i=1,nb
         if (annotations(i).eq.chosen_annotation) then
            target_nb = target_nb + 1
            target_x(target_nb) = x(i)
            target_y(target_nb) = y(i)
         endif
      enddo
      end
