C    soas_file.f: handling of data files
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

      subroutine load(np,x,y,filename,ileng,datachanged,iload,
     :     listpattern, llistpattern, colformat)
      parameter (N=2**14,iextmax=14)
      real*4 x(*),y(*)
      integer ileng,iload
      character*128  filename    ! of length ileng
      logical datachanged,expert
                                ! ex=file exists, datachanged=true if success
      character*4 ext(iextmax)  ! extensions to look for
c
      character*128 listpattern  ! in load, save, browse
      integer llistpattern
      character*10 colformat
c     to add others, don't forget to change iextmax accordingly.
      DATA ext /'.ocw','.OCW',
     :     '.oew','.OEW','.oxw','.OXW',
     :     '.txt','.TXT','.asc','.ASC',
     :     '.dat','.DAT','.txt','.TXT'/ 
      common /expert/ expert
C     Code to call the promptfor external routine:
      character*128 promptfor

 303  format(A)
 304  format('INFO : buffer name is ',A)
C 12   format('ERROR : file ',A,' not found')

C 1    format(a)                 !(q,a)

      if (llistpattern.ne.0) then
         call soas_system('ls '//listpattern(1:llistpattern))
      else 
         call soas_system('ls ')
      endif

      if (ileng.ne.0) write(6,304) filename(1:ileng)
      
      if(.not.expert) then
         if(iload.eq.2) write(6,303) 'INFO : You are about to load'//
     :        ' forward SWV current.' ! 
         if(iload.eq.3) write(6,303)  'INFO : You are about to load'//
     :        ' backward SWV current.' !   
      endif  
      
      filename = promptfor('Data filename ([return to abort]) :','f')
      ileng=lnblnk(filename)

      call load_only(np,x,y,filename,ileng,datachanged,iload,colformat)
      end

C     Vincent Fourmond: a new routine that does the only job of loading
C     a file provided as an argument. No user interaction
      subroutine load_only(np,x,y,filename,ileng,datachanged,iload,
     :     colformat)
      parameter (N=2**14,iextmax=14)
      real*4 x(*),y(*)
      integer ileng,iload
      character*128  filename    ! of length ileng
      logical ex,datachanged,expert
                                ! ex=file exists, datachanged=true if success
      character*10 colformat

      character*4 ext(iextmax)  ! extensions to look for
      DATA ext /'.ocw','.OCW',
     :     '.oew','.OEW','.oxw','.OXW',
     :     '.txt','.TXT','.asc','.ASC',
     :     '.dat','.DAT','.txt','.TXT'/ 
      common /expert/ expert


 12   format('ERROR : file ',A,' not found')

C     From now on, the code is copied verbatim from load
      ileng=lnblnk(filename)
      if(ileng.ne.0) then
c     remove first and last blanks in filename
         do while ((filename(1:1).eq.' ').and.(ileng.ge.1)) 
            filename(1:ileng-1)=filename(2:ileng)
            ileng=ileng-1
         enddo
         do while ((filename(ileng:ileng).eq.' ').and.(ileng.ge.1)) 
            ileng=ileng-1
         enddo
c     does the file exist ?
         inquire(file=filename(1:ileng),exist=ex) 
c     look for different extensions if it doesn t  
         iext=0  
         do while ((.not.ex).and.(iext.le.iextmax-1))
            iext=iext+1
            filename(1:ileng+4)=filename(1:ileng)//ext(iext)(1:4) 
            inquire(file=filename(1:ileng+4),exist=ex) 
            if (ex) then        ! found 
               ileng=ileng+4
               filename(1:ileng)=filename(1:ileng)//ext(iext)(1:4)
            endif
         enddo
c     READ
         if (ex) then           ! file found
            call get_xy_from_file(filename,ileng,iload,np,x,y,colformat)
         else                   ! does not exist
            write(6,12) filename(1:ileng) ! file not found
            np=0
            ileng=0
         endif
      else
         np=0
      endif

      if (np.eq.0) then
         datachanged=.false.
      else
         datachanged=.true.
      endif

      ileng=lnblnk(filename)    ! update cause may have changed if extension has been guessed

      return
      end

      subroutine get_xy_from_file(file,ileng,iload,np,x,y,colformat)
      parameter (N=2**14)
      real*4 x(*),y(*),y0,y1,x0,x1
      character*128 file
      integer ileng,iload,np,i
      character*10 colformat
      character*128 dum
C 303  format(A)

c     open. on error opening go to 951
      open(unit=1,file=file(1:ileng),status='old',err=951) 
      np=0


c     GPES
      if (colformat(1:4).eq.'GPES') then
c     iload = 1
         if (iload.eq.1) then
            if (file(ileng-3:ileng-2).eq.".o") then
c     avoid crash while trying to load empty/unrecognized file
               read(1,*,end=931,err=931)
               read(1,*,end=931,err=931)
            endif
            do i=1,N
               read(1,*,end=931,err=101) x(np+1),y(np+1)
               np=np+1
 101           continue
            enddo
c     iload = 2: forward y 3
         elseif((iload.eq.2)) then
         call changename(file,ileng,iload) ! for swv files
            do i=1,N
               read(1,*,end=931,err=102) x(np+1),y0,y(np+1)
               np=np+1
 102           continue
            enddo
c     iload = 3: backward y = Y3-Y2
         elseif((iload.eq.3)) then
         call changename(file,ileng,iload) ! for swv files
            do i=1,N
               read(1,*,end=931,err=103) x(np+1),y0,y1
               y(np+1)=-y0+y1
               np=np+1
 103           continue
            enddo
         endif ! iload

c     CH
      elseif (colformat(1:2).eq.'CH') then ! CH
         if (iload.eq.1) then
            do i=1,N
c     rem: if SWV, default is net current, OK. OK pour chronotampero.
               read(1,*,end=931,err=111) x(np+1),y(np+1)
               y(np+1)=-y(np+1) ! us2eur
               np=np+1
 111           continue
            enddo 
         elseif (iload.eq.2) then ! forward
            call changename(file,ileng,iload) ! for swv files
            do i=1,N
               read(1,*,end=931,err=112) x(np+1),y0,y(np+1)
               y(np+1)=-y(np+1) ! us2eur
               np=np+1
 112           continue
            enddo
         elseif (iload.eq.3) then ! backward
            call changename(file,ileng,iload) ! for swv files
            do i=1,N
               read(1,*,end=931,err=113) x(np+1),y0,y1,y(np+1)
               y(np+1)=-y(np+1) ! us2eur
               np=np+1
 113           continue
            enddo
         endif
         
c     EGGexport
      elseif (colformat(1:9).eq.'EGGexport') then ! EGGexport
         if (iload.eq.1) then
            do i=1,N
               read(1,*,end=931,err=131) x(np+1),y(np+1)
               np=np+1
 131           continue
            enddo 
         else
 132        format ('ERROR: SWV format yet undefined for EGGexport.'//
     :           ' Ask christophe.leger@ibsm.cnrs-mrs.fr to add it.')
            write(6,132)
         endif
         
c     EGGsave
      elseif (colformat(1:7).eq.'EGGsave') then ! EGGsave
         if (iload.eq.1) then
c     try find out what that is and change iliad if eq 1
            read(1,*,err=951,end=931)
            read(1,*,err=951,end=931)
            read(1,*,err=951,end=931) dum,dum
            if (dum(1:3).eq.'SWV') then
               iload = 11
            elseif (dum(1:2).eq.'CA') then
               iload = 4
c$$$  elseif (dum(1:2).eq.'CV') then
c$$$  continue
            endif
         endif
         if (iload.eq.1) then
            do i=1,N
               read(1,*,end=931,err=121) y(np+1), x(np+1)
               y(np+1)=-y(np+1)
               np=np+1
 121           continue
            enddo 
         elseif (iload.eq.2) then ! forward
         call changename(file,ileng,iload) ! for swv files
            do i=1,N
               read(1,*,end=931,err=122) y0,x0
               read(1,*,end=931,err=122) y1,x1
               x(np+1)=(x0+x1)/2.
               y(np+1)=-y1
               np=np+1
 122           continue
            enddo 
         elseif (iload.eq.3) then ! backward
         call changename(file,ileng,iload) ! for swv files
            do i=1,N
               read(1,*,end=931,err=123) y0,x0
               read(1,*,end=931,err=123) y1,x1
               x(np+1)=(x1+x0)/2.
               y(np+1)=-y0
               np=np+1
 123           continue
            enddo 
         elseif (iload.eq.11) then ! net
         call changename(file,ileng,iload) ! for swv files
            do i=1,N
               read(1,*,end=931,err=125) y0,x0
               read(1,*,end=931,err=125) y1,x1
               x(np+1)=(x1+x0)/2.
               y(np+1)=y0-y1
               np=np+1
 125           continue
            enddo 
         elseif (iload.eq.4) then ! CA
            do i=1,N
               read(1,*,end=931,err=124) y(np+1), x1, x(np+1)
               y(np+1)=-y(np+1)
               np=np+1
 124           continue
            enddo 
         endif
         
      endif                     ! other format

c     EOF
      close(1)
 931  continue

      if (np.eq.0) then
 932     format ('ERROR : no data points found in ',A,'; sorry.')
         write(6,932) file(1:ileng)
      elseif (np.eq.N) then
 933     format ('WARNING: the file ',A,
     :     ' contains too many points, the end was skipped.') !
         write(6,933) file(1:ileng)
      elseif (i.eq.N) then
 934     format ('WARNING: the file ',A,
     :     ' is too long, the end was skipped.') !
         write(6,934) file(1:ileng)
      endif
      close(1)
      return                    ! OK

c     ERROR OPENING
 951  continue
 952  format ('ERROR while opening ',A,'; sorry.')
      write(6,952) file(1:ileng)
      np=0
      close(unit=1)
      return

      end


      subroutine save(np,x,y,filenamein,ilengin,idelta,colformat)
      parameter (N=2**14)
      real*4 x(*),y(*)
      integer ileng, ilengin, idelta, np ! save 1 point in idelta
      character*128 filename,filenamein, promptfor
      character*1 answer
      logical ex,conf
      character*10 colformat

C 1    format(a)                 !q,a)
      call soas_system("ls")

 303  format(A)
C 304  format('INFO : buffer name is ',A)
      answer='0'
      filename = promptfor('Filename (['//filenamein(1:ilengin)//
     :     '],q to abort) :', 'f')   !
      ileng=lnblnk(filename)
      if (.not.((ileng.eq.1).and.(filename(1:1).eq.'q'))) then
         if (ileng.eq.0) then
            ileng=ilengin
            filename(1:ilengin)=filenamein(1:ilengin)
         else
c     (ileng.ne.0)
c     remove first and last blanks in filename
            do while ((filename(1:1).eq.' ').and.(ileng.ge.1)) 
               filename(1:ileng-1)=filename(2:ileng)
               ileng=ileng-1
            enddo
            do while ((filename(ileng:ileng).eq.' ').and.(ileng.ge.1)) 
               ileng=ileng-1
            enddo
c     append to current buffer name if starts with ``!!''
            if ((filename(1:2).eq.'!!').and.(ileng.ge.2)) then
               filename(1:ilengin+ileng-2)=filenamein(1:ilengin)//
     c              filename(3:ileng)
               ileng=ilengin+ileng-2
            endif
         endif
c     file already exists ? (if not saving data in i.dat)
         if (filename(1:ileng).ne.'i.dat') then
            inquire(file=filename(1:ileng),exist=ex) 
            if (ex) then        ! file exists
 305           format('WARNING : file ',A,' already exists.')
               write(6,305) filename(1:ileng)
               call confirm('overwrite',9,conf,.false.)
            endif
         else
            ex=.false.
         endif

         if ((conf).or.(.not.ex)) then 
            if(ex) then
 306           format('INFO : removing existing file ',A)
               write(6, 306) filename
               call system('rm '//filename)
            endif
            open(unit=1,file=filename(1:ileng),status='NEW',err=951) !

            if ((colformat(1:4).eq.'GPES')) then
               do i=1,np,idelta
                  write(1,*,err=941) x(i),y(i)
               enddo
            elseif ((colformat(1:9).eq.'EGGexport')) then
               do i=1,np,idelta
                  write(1,*,err=941) x(i),y(i)
               enddo
            elseif (colformat(1:2).eq.'CH') then
               do i=1,np,idelta
                  write(1,*,err=941) x(i),-y(i)
               enddo
            elseif (colformat(1:7).eq.'EGGsave') then
               do i=1,np,idelta
                  write(1,*,err=941) -y(i),x(i)
               enddo
            endif
            close(unit=1)

c     buffer name changed only if not saving one point in idelta.ne.1
            if (idelta.eq.1) then
               ilengin=ileng    
               filenamein(1:ilengin)=filename(1:ileng)
            endif
            
         else
            write(6,303) 'WARNING : data NOT saved.' 
         endif
      else
         write(6,303) 'WARNING : data NOT saved.' 
      endif
      
      return                    ! OK

c     ERROR writing
 941  continue
 942  format ('ERROR while writing ',A,
     :     '; file may not be saved properly!')
      write(6,942) filename(1:ileng)
      close(unit=1)
      return
c     ERROR OPENING
 951  continue
 952  format ('ERROR while opening ',A,
     :     '; file not saved!')
      write(6,952) filename(1:ileng)
      close(unit=1)
      return
      end


      subroutine Changename(file,ileng,iload) ! for swv files
      integer ileng,iload
      character*128 file
      if (file(ileng-3:ileng-3).eq.'.') then
         file(ileng-1:ileng+2)=file(ileng-3:ileng) 
         if ((iload.eq.11)) then 
            file(ileng-3:ileng-2)='.n'
         elseif (iload.eq.2) then
            file(ileng-3:ileng-2)='.f'
         elseif (iload.eq.3) then
            file(ileng-3:ileng-2)='.b'
         endif
         ileng=ileng+2
      endif
      return
      end

      subroutine sayfileformat(listpattern, llistpattern,colformat)
      character*128 listpattern  ! in load, save, browse
      integer llistpattern
      character*10 colformat
 317  format('INFO : list pattern set to ',A,'.') 
 318  format('INFO : column format set to ',A,'.') 
C 303  format(A)
      write(6,317) listpattern(1:llistpattern)
      write(6,318) colformat(1:lnblnk(colformat))
      return
      end

      subroutine loadformatfromfile(listpattern, llistpattern,
     :     colformat,check_pt_off) 
      logical check_pt_off      ! if=T, remove data pts off scale after loading
      character*128 listpattern  ! in load, save, browse
      integer llistpattern
      character*10 colformat
      logical ex
      character*128 tmp(20),chain
 317  format('INFO : list pattern set to ',A,'.') 
 318  format('INFO : file format set to ',A,'.') 
 303  format(A)

      inquire(file='soas.ff',exist=ex) 
      if (ex) then
         write(6,303) 'INFO : loading file format from file soas.ff'
         open (unit=9,file='soas.ff',status='old')
         nop=0
         do j=1,20
            read(9,*,err=146,end=98) tmp(j)
            nop=nop+1
         enddo
 98      continue
         do j=1,nop
c            write(6,*) '*',tmp(j)(1:12),'*',lnblnk(tmp(j))
c            if (tmp(j)(1:12).eq.'-listpattern') write(6,*) 'yes'
            if (tmp(j)(1:3).eq.'-ff') then
               if ((tmp(j)(4:lnblnk(tmp(j))).eq.'GPES').or.
     :              (tmp(j)(4:lnblnk(tmp(j))).eq.'Gpes')) then
                  listpattern='*.[oO]?? *.[Dd][Aa][Tt]'
                  llistpattern=23
                  check_pt_off=.true.
                  colformat='GPES'
                  write(6,318) tmp(j)(4:lnblnk(tmp(j)))
               elseif (tmp(j)(4:lnblnk(tmp(j))).eq.'EGGsave') then
                  listpattern='*.[Dd][Aa][Tt]'
                  llistpattern=14
                  check_pt_off=.true.
                  colformat='EGGsave'
                  write(6,318) tmp(j)(4:lnblnk(tmp(j)))
               elseif (tmp(j)(4:lnblnk(tmp(j))).eq.'EGGexport') then
                  listpattern='*.[Tt][Xx][Tt] *.[Dd][Aa][Tt]'
                  llistpattern=29
                  colformat='EGGexport'
                  write(6,318) tmp(j)(4:lnblnk(tmp(j)))
               elseif (tmp(j)(4:lnblnk(tmp(j))).eq.'CH') then
                  listpattern='*.[Tt][Xx][Tt] *.[Dd][Aa][Tt]'
                  llistpattern=29
                  check_pt_off=.false.
                  colformat='CH'
                  write(6,318) tmp(j)(4:lnblnk(tmp(j)))
               endif
            elseif (tmp(j)(1:12).eq.'-listpattern') then
c                  write(6,*) '*'
c     marche pas
               if (llistpattern.eq.0) then 
                  listpattern=tmp(j)(13:lnblnk(tmp(j))) 
                  llistpattern=lnblnk(tmp(j))-12 
c                  write(6,*) '**'
               else
                  listpattern(1:llistpattern+1+lnblnk(tmp(j))-12)
     :                 =listpattern(1:llistpattern)//
     :                 ' '//tmp(j)(13:lnblnk(tmp(j)))
                  llistpattern=llistpattern+1+lnblnk(tmp(j))-12
c                  write(6,*) '****'
               endif
               write(6,317) listpattern(1:llistpattern)
            elseif (tmp(j)(1:10).eq.'-colformat') then
               chain=tmp(j)(11:lnblnk(tmp(j)))
               lchain=lnblnk(tmp(j))-10
               if (lchain.ne.3) then
                  write(6,303) 'ERROR : wrong column format'
               else
                  colformat(1:3)=chain(1:3)
               endif
               write(6,318) colformat
            elseif (tmp(j).eq.'checkptoff') then 
               check_pt_off=.true.
               write(6,303) 'INFO : argument checkptoff.'
            endif
         enddo                  ! nop
      endif                     ! ex

c      write(6,303) 'New file format is:'
c      call sayfileformat(listpattern, llistpattern,
c     :     ndummyread, us2eur, colformat)
      close(9)
c      call sayfileformat(listpattern, llistpattern,
c     :           ndummyread, us2eur, colformat)
 146  continue
      return
      end
      
