C    soas_log.f: various regression and output file handling functions
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

      subroutine reg(np,x,y,datachanged)
      parameter (N=2**14)
      character*10 code
      real*8 xu,yu
      real*4 x4,y4,a,b
      real*4 x(*),y(*),yt(N),xmin,xmax,x_begin,x_end,ctemp
      real*4 rate
      integer np, i_begin, i_temp, i_end
      logical expert, datachanged, inhib
      common /expert/ expert
      common /temperature/ ctemp
      common /comslope/ a
 303  format (A)
 304  format('T=',G12.4)
 204  format('E1/2=-b/a     n_app       a           b (ax+b)    kapp')
 203  format('1/(2.3a)      10**b       a           b (ax+b)')
 202  format(4(G12.4))
 206  format(5(G12.4))
      call SSORT(X,Y,np,2) !sort2(np,x,y)
      inhib=.false.
      datachanged=.false.
      i_begin=1
      i_end=np
      code(1:1)=' '
      f=96500/(2.3*8.3144*(ctemp)) ! a=nf
      write(6,304) ctemp
      a=reglin2(x,y,i_begin,i_end)
      b=ord2(x,y,i_begin,i_end)
      if (.not.expert) then
         write(6,303) 'use left/right buttons or b/e for limits' !
         write(6,303) 'use mid button or q to Quit' !
         write(6,303) 'use u to quit subtracting linear trend'
         write(6,303) 'use v to quit dividing by linear trend'
c        write(6,303) 'use n to quit dividing by normalized linear trend'
         write(6,303) 'use e to quit normalizing with exponential '//
     :        'decay matching the selected linear region'
         write(6,303) 'use space to write regression data to '//
     :        'output file'
      endif
      if (inhib) then
         write(6,203)           !'E1/2=-b/a   n_app  a      b (ax+b)'
      else
         write(6,204)
      endif
      do while((code(1:1).ne.'&').and.(code(1:1).ne.'Q')
     :     .and.(code(1:1).ne.'U').and.(code(1:1).ne.'N')
     :     .and.(code(1:1).ne.'V')
     :     .and.(code(1:1).ne.'E'))                    ! right button, or q, or u
         call gr_curs(xu,yu,x4,y4,code)
         if ((code(1:1).eq.'I')) then
            inhib=.not.inhib
            if (inhib) then
               write(6,203)     !'E1/2=-b/a   n_app  a      b (ax+b)'
            else
               write(6,204)
            endif
         endif
         if ((code(1:1).eq.'^').or.(code(1:1).eq.'B')) then
            x_begin=real(xu)    ! left button
            call locate(x,np,x_begin,i_begin)
         endif
         if ((code(1:1).eq.'*').or.(code(1:1).eq.'E')) then
            x_end=real(xu)      ! right button
            call locate(x,np,x_end,i_end)
         endif
         if (code(1:1).eq.' ') then ! Space pressed 
            ! We add to the default output file
            call writeregdata(x(1), x_begin, x_end, a, b)
         endif
         if (i_begin.gt.i_end) then
            i_temp=i_begin
            i_begin=i_end
            i_end=i_temp
            a=reglin2(x,y,i_begin,i_end)
            b=ord2(x,y,i_begin,i_end)
            i_temp=i_begin
            i_begin=i_end
            i_end=i_temp
         else
            a=reglin2(x,y,i_begin,i_end)
            b=ord2(x,y,i_begin,i_end)
         endif        
         if ((code(1:1).ne.'&').and.(code(1:1).ne.'Q')
     :        .and.(code(1:1).ne.'U').and.(code(1:1).ne.'N')
     :        .and.(code(1:1).ne.'V')) then
            if (inhib) then
               write(6,202) -1/(2.3*a),10**b,a,b
            else
               write(6,206) -b/a,a/f,a,b, - a/(b - a*x(1))
            endif
         endif
         do i=1,np
            yt(i)=b+a*x(i)
         enddo
         call plot(np,x,y,1)    ! plot data
         call plot(np,x,yt,0)   ! add best line
         call plotdiff(x,yt,y,1,np,.false.) ! plot residue
         call reclim(np,x,y)    ! recover limits
         call plotline(x(i_begin),-10.,x(i_begin),10.) ! plot lim. as...
         call plotline(x(i_end),-10.,x(i_end),10.) ! ... vertical lines
      enddo
      if (code(1:1).eq.'U') then
         datachanged=.true.
         do i=1,np
            y(i)=y(i)-yt(i)
         enddo
      elseif (code(1:1).eq.'N') then
         datachanged=.true.
C     We normalize with respect to the first point in the interval, which
C     keeps the same value.
         do i=2,np
            y(i) = y(i) * yt(1)/ yt(i)
         enddo
      elseif (code(1:1).eq.'V') then
         datachanged=.true.
         do i=1,np
            y(i) = y(i) / yt(i)
         enddo
      elseif (code(1:1).eq.'E') then
         datachanged=.true.
C     We infer an exponential decay from the linear regression.
         rate = a/(b - a*x(1))
         do i=2,np
            y(i) = y(i) / exp(rate * (x(i)-x(1)))
         enddo
      endif
      return
      end


C     A subrouting to output to the common output file the information
C     about the most recent linear fit. 
      subroutine writeregdata(x_org, x_beg, x_end, a, b) 
      real*4 x_org,              ! the first point in the buffer
     :     x_beg,               ! the first point used for the linreg
     :     x_end,               ! the last point used for the linreg
     :     a,b                  ! a * x + b
      character*128 filename
      integer ileng
      logical ex, backspacerequired
      common /outpeak/ filename, ileng
      common /backspacerequired/ backspacerequired

      inquire(file=filename(1:ileng),exist=ex)
      open(unit=9,file=filename(1:ileng),status='unknown',err=24)
      if (ex) then
         do i=1,10000
            read(9,*,end=21)
         enddo
 21      continue
         if (backspacerequired.eqv..true.) call backspace9
      else
 303     format(5(A))
         write(9,303)'# xorg','x_beg','x_end',
     :        'a ','b', 'teff'
      endif
 23   format (6(G12.4))
      write(9,23,err=24) x_org, x_beg, x_end, a, b, -(a * x_beg + b)/a
 304  format('INFO : saved in ',A, ':')
      write(6,304) filename(1:ileng)
      write(6,23,err=24) x_org, x_beg, x_end, a, b, -(a * x_beg + b)/a
      endfile 9
      close(9)
      return
 305  format('ERROR during writing of ',A)
 24   write(6,305) filename(1:ileng)
      return
      end


      subroutine tlog(np,x,y,choice)  ! 9
      parameter(N=2**14)
      real x(*),y(*)
      integer np,choice         ! choice=1, log_10, choice=2 log_e (ln)
 303  format(A)
      call gr4_give('X',np,x)   ! transfer data from xy to XY
      call gr4_give('Y',np,y)
      if (choice.eq.1) then
         call exec_greg('let y log10(y)')
c     call exec_greg('@GAG_INIT:soas_log.greg')
         write(6,303) 'INFO: log_10(Y)'
      else
c     call exec_greg('@GAG_INIT:soas_ln.greg')
         call exec_greg('let y log(y)')
         write(6,303) 'INFO: log_e(Y)'
      endif
c     on error return
c     let y log10(y)
      call gr4_get('X',np,x)    ! returns NXY into np, X into x
      call gr4_get('Y',np,y)    ! returns NXY into np, Y into y
      return
      end


      subroutine klt(np,x,y)      
      parameter(N=2**14)
      real x(*),y(*),a,b,yt(N)
 10   format('ilim extrap = ',G12.4)
      call gr4_give('X',np,x)   ! transfer data from xy to XY
      call gr4_give('Y',np,y)
c     call exec_greg('@GAG_INIT:soas_kl.greg')
      call exec_greg('let y 1|y')
      call exec_greg('let x x*2*3.1415*60.')
      call exec_greg('let x 1|sqrt(x)')
      call gr4_get('X',np,x)    ! returns NXY into np, X into x
      call gr4_get('Y',np,y)    ! 
      call plot(np,x,y,1)
      a=reglin2(x,y,1,np)
      b=ord2(x,y,1,np)
      do i=1,np
         yt(i)=b+a*x(i)
      enddo
      call plot(np,x,yt,0)      ! add best line
      write(6,10) 1./b
      return
      end
