C    soas_misc.f: various functions
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

      subroutine backspace9()
      backspace 9
      return
      end

      integer function ich(ch,idef,imin,imax) ! character*1 2 int
      integer idef,imax
      character*1 ch,ch2
      logical success
 1    format(I1)
      success=.false.
      do i=imin,imax
         write(ch2,1) i
         if(ch2.eq.ch) then
            ich=i
            success=.true.
         endif
      enddo
      if (.not.success) then
 403     format('WARNING : Option ''',A,''' not recognized')
 404     format('          Using default (',I1,') instead')
         write(6,403) ch(1:1)
         write(6,404) idef
         ich=idef
      endif
      return
      end
 
      subroutine ichlog(ch,imax,ich,success) ! character*1 2 int
      integer ich,imax
      character*1 ch,ch2
      logical success
 1    format(I1)
      success=.false.
      do i=1,imax
         write(ch2,1) i
         if(ch2.eq.ch) then
            ich=i
            success=.true.
         endif
      enddo
      return
      end
 
      subroutine prompt(cha)    ! prompt string cha
      character*(*) cha
      call uputs(cha)
      end

      subroutine ChangeDirectory(directory,l1,l2)
      character*128 directory
      integer l1,l2
      logical ex
      character*128 expandfile, promptfor
      
 303  format(A)
      call soas_system('ls -F | grep /')
c     list directories, or ls -log | grep drw
 306  format('INFO : working directory is ',A)
      call GetCwdShort(directory,l1,l2) ! hereafter
      write(6,306) directory(1:l1)
      directory = promptfor('New directory ([return to abort]) : ','d')

C     Expand file name
      directory = expandfile(directory)
      l1=lnblnk(directory)

c     Check if the directory exists 
      inquire(file=directory(1:l1),exist=ex) ! could be done with access(3F)
      if (l1.ne.0) then
         if (ex) then
            call chdir(directory(1:l1)) ! irix or standard ?
            call GetCwdShort(directory,l1,l2) ! hereafter
            write(6,306) directory(1:l1)
            call testdirectory() ! hereafter
         else
 307        Format('ERROR : directory ',A,' does not exist.')
            write(6,307) directory(1:l1)
         endif
      else
         write(6,303) 'INFO : directory not changed.'
      endif
      return
      write(6,303) 'ERROR, directory not changed.'
      return
      end
      
      subroutine GetCwdShort(d,l1,l2) ! get working directory in string d(1:l1)
      character*128 soas_getcwd, d
      integer l1,l2
      d = soas_getcwd()
      l1=50
      do while((d(l1:l1).eq.' ').and.(l1.gt.2))
         l1=l1-1
      enddo
      l2=50  ! d(l2:l1) contains last part of w.d. i.e. /000202
      do while((d(l2:l2).ne.'/').and.(l2.gt.2))
         l2=l2-1
      enddo
      return
      end

      subroutine TestDirectory  ! allowed to write here ?
      integer*4 i,access
 303  format(A)
      i=access('.','w') 
      if (i.ne.0) write(6,303) 'WARNING : You will not'//
     :     ' be allowed to write anyting in this directory.' !
      return
      end

      subroutine TestHome
      character*128 homedir, homefile
      integer*4 i1,i2,access

 303  format(A)
c      write(6,303) 'INFO : testing home directory...'
 304  format('INFO : testing home directory (',A,')...')
      write(6,304) homedir()
c     test existence of ~/gregtmp/
      i1=access(homefile('gregtmp'),' ') 
      if (i1.ne.0) then
         write(6,303) 'WARNING : directory '//
     :        homefile('gregtmp') // 'does not exist'
         call prompt('Trying to make it...')
         call soas_system('mkdir '//homefile('gregtmp'))
         i1=access(homefile('gregtmp'),' ') ! test again
         if (i1.ne.0) then
            write(6,303) ' failed. Set your home directory properly.'
         else
            write(6,303) ' successful.'
         endif
      endif
c     test existence of ~/.gag.dico
      i2=access(homefile('.gag.dico'),' ') 
      if (i2.ne.0) then
         write(6,303) 'WARNING : file '//
     :        homefile('.gag.dico') // ' does not exist' !
         call prompt('INFO : Trying to make it...')
         call soas_system('touch '//homefile('.gag.dico'))
         i2=access(homefile('.gag.dico'),'w') ! test again
         if (i2.ne.0) then
            write(6,303) ' failed.'
         else
            write(6,303) ' successful.'
c     writing it then
            open(unit=9,file=homefile('.gag.dico'), status='old')
            write(9,303) 'GAG_TMP: '//homefile('gregtmp/')
            write(9,303) 'GAG_LOG: '//homefile('gregtmp/')
c     the folowing line useful only if new macros are defined.
            write(9,303) 'GAG_INIT: '//homefile('greg/')
c     the following lines for MacOS 10.
c     GAG_PROC (important) and GAG_SCRATCH (possibly unused, not sure)
c     If GREG is run before SOAS, and there is not .gag.dico in the user
c     directory, it puts stuff in $HOME, but then removes that pesky
c     directory when done.  Soas leaves the pesky directories alone.
            write(9,303) 'GAG_PROC: '//homefile('gregtmp/')
            write(9,303) 'GAG_SCRATCH: '//homefile('gregtmp/')
            close(9)
         endif
      endif    
      if ((i2.eq.0).and.(i1.eq.0)) then
         write(6,303) '... alright.'
      elseif ((i2.eq.1).and.(i1.eq.1)) then
         write(6,303) 'WARNING : could not find/create '//
     :        '~/gregtemp directory' !
         write(6,303) '          browse & fit will fail.'
         write(6,303) '          could not find/create '//'
     :        ~/.gag.dico file'
      elseif (i2.eq.0) then     ! no gregtmp
         write(6,303) 'WARNING : could not find/create '//
     :        '~/gregtemp directory' !
         write(6,303) '          browse & fit will fail.'
      elseif (i1.eq.0) then
         write(6,303) 'WARNING : could not find/create '//
     :        '~/.gag.dico file'
      endif
      return
      end

      subroutine OnSEnVa(ch,ileng) ! quit
      character*128 ch
      integer ileng
      logical conf
 303  format(A)
      call gr_exec('clear')     ! clear graphic window
      call confirm('quit',4,conf,.true.)
      if (conf) then
         ch(1:1)='q'
         write(6,303) 'Bye then.' ! quit, really...
         call flushtemp         ! hereafter, flush ~/gregtmp/
      else                      ! do not quit 
         ch(1:1)=' '            ! reset choice
         write(6,303) 'Excellent!!!' ! on revient
      endif
      ileng=1
      return
      end
      
      subroutine flushtemp      ! rm temp files ~/gregtmp/
      character*128 homefile
      call soas_system('rm -f '//homefile('gregtmp/temp*.ps')) !      
c      call soas_system('rm -f '//home(1:lhome)//'/gregtmp/soas*.tmp*') !
      call soas_system('rm -f '//homefile('gregtmp/LOG*')) !
      call soas_system('rm -f '//homefile('gregtmp/greg.log*')) !
c$$$c     useful for MacOS 10 only
c$$$      call soas_system('rm -df '//home(1:lhome)//
c$$$     :     '/gregtmp/[0-9][0-9][0-9][0-9][0-9]?') !
      return
      end

      subroutine checkbirthdayfromfile  ! very useful part !
      parameter (ndatemax=100)  ! to change to add birthdays.
      character*24 soas_fdate,today
      character*128 name
      character*3 month
      integer iday
      character*128 email
      character*2 day
      character*6 fulldate
      integer lname,lemail
C      character*128 home         ! name of ~ = home(1:lhome)
C      integer lhome             ! 
C      character*128 SoasD        ! has to be set in soas_include.f
C      integer lSoasD            ! SoasD(1:lSoasD), dir containgin soas source
      logical expert
      character*128 datafile
      external soas_fdate
      common /expert/ expert

      open(unit=1,file=datafile('soas.birthdays'),
     :     status='old',err=100) !
 303  format(A)
 302  format(A3)
 301  format(I2)
      today=soas_fdate()
      do i=1,ndatemax
         read(1,303,end=98,err=97) name 
         lname=lnblnk(name)
         if (lname.ne.0) then
            read(1,302,end=97,err=97) month
            read(1,301,end=97,err=97) iday
            read(1,303,end=97,err=97) email
            lemail=lnblnk(email)
            write(day,301) iday
            if (day(1:1).eq.' ') day(1:1)='0'
            fulldate=month(1:3)//' '//day(1:2)
            if (today(5:10).eq.fulldate(1:6)) then
               write(6,*)
               if (name(lname:lname).eq.'s') then
 304              format('It''s ',A,''' birthday !!!')
                  write (6,304) name(1:lname)
               else
 305              format('It''s ',A,'''s birthday !!!')
                  write (6,305) name(1:lname)
               endif
               write(6,303) email(1:lemail)
               write(6,*)
            endif
         endif
      enddo

      continue
      if (expert) write(6,303) 'Error opening the file ',
     :     datafile('soas.birthdays') !
      return
 98   continue
      close(1)
      return
 97   continue
 397  format('Error reading the file ',A)
      if (expert) then
         write(6,397) datafile('soas.birthdays') !
         write(6,*)
      endif
      close(1)
 100  return
      end
      
      subroutine gpes2dat(name,leng)
      parameter (next1=4,next2=4)
      integer leng
      character*128 name
      character*4 extension1(next1)
      character*4 extension2(next2)
      logical found
      data extension1 /'.ocw','.oew','.oxw','.txt'/
      data extension2 /'.OCW','.OEW','.OXW','.TXT'/
      if (leng.eq.0) return
      found=.false.
      do i=1,next1
         if ((name(leng-3:leng).eq.extension1(i)(1:4))) found=.true.
      enddo
      if (found) then
         name(leng-3:leng)='.dat'
      else
         do i=1,next2
            if ((name(leng-3:leng).eq.extension2(i)(1:4))) found=.true.
         enddo
         if (found) name(leng-3:leng)='.DAT'
      endif
      return
      end

      subroutine confirm(c,l,conf,def)
      logical conf,ok,def
      character*128 c
      character*10 ch, promptfor
      external promptfor
      integer l,ileng
      ok=.false.
      do while (.not.(ok))
         if (def) then
            ch = promptfor('Do you wish to '//c(1:l)//' ([y]/n) ?','y')
         else
            ch = promptfor('Do you wish to '//c(1:l)//' (y/[n]) ?','y')
         endif
         ileng=lnblnk(ch)
         if (((ch(1:1).eq.'y').and.(ileng.eq.1))
     :        .or.((ch(1:3).eq.'yes').and.(ileng.eq.3))
     :        .or.((ileng.eq.0).and.def)) then 
            conf=.true.
            ok=.true.
         elseif (((ch(1:1).eq.'n').and.(ileng.eq.1))
     :           .or.((ch(1:2).eq.'no').and.(ileng.eq.2))
     :           .or.((ileng.eq.0).and.(.not.def))) then
            conf=.false.
            ok=.true.
         endif
      enddo
      return
      end

      subroutine readtemp(ctemp)
      logical ex
      real ctemp
 312  format('INFO : temperature set to ',G12.4)
c     read temperature in temperature.info, if it exists
      inquire(file='temperature.info',exist=ex) 
      if (ex) then
         open (unit=9,file='temperature.info',status='old')
         read(9,*,err=146) ctemp
         write(6,312) ctemp
      endif
 146  continue
      return
      end

C     Spawns the command _command_, printing out debugging information
C     if applicable.
      subroutine soas_system(command)
      character*(*) command
      logical debugon
      common /debug/ debugon

      if(debugon) then
 300     format("DEBUG: trying to run :'", A, "'")
         write(6, 300) command  ! (1:lnblnk(command))
      endif
      call system(command)
      end
