C    soas_peaks.f: peak finders
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

      real function xyint(x,y,i1,i2)
      real x(*),y(*)
      integer i1,i2
      xyint=0
      if (i2.gt.i1) then
         do i=i1+1,i2
            xyint=xyint+y(i)*(x(i)-x(i-1))
         enddo
      else
         do i=i2+1,i1
            xyint=xyint+y(i)*(x(i)-x(i-1))
         enddo
      endif
      xyint=abs(xyint)
      return
      end


      subroutine search(np,x,y,i1,i2,ichoice,xpos,ypos,
     :     width,widthl,widthr,ysum,ysuml,ysumr,idraw,iprint) !
      parameter (N=2**14)
c     looks between x(i1) and x(i2) to find
c     the max (if choice=1), the min (-1) or either (0)
      real*4 x(*),y(*)
      integer choice,np,ichoice
      real*4 xpos,ypos,width,widthl,widthr,ysum,ysuml,ysumr
      real*4 ymin,ymax
      logical idraw,iprint

      if (i2-i1.lt.3) return 

      choice=ichoice            ! to avoid changing it

      ymin=1000.
      ymax=-1000.
      ysum=0
      ysum=xyint(x,y,i1,i2)
      do i=i1+1,i2              ! trouve position des max, min, et |ysum| 
         if (y(i).gt.ymax) then
            ymax=y(i)
            ima=i
         endif
         if (y(i).lt.ymin) then
            ymin=y(i)
            imi=i
         endif
      enddo
      ysum=abs(ysum)

      if (choice.eq.0) then
         choice=1
         if (abs(ymin).gt.abs(ymax)) choice=-1 ! look for min
      endif
         
      if (choice.eq.-1) then
         ihp=imi
         do while((y(ihp).lt.(y(imi)/2.)).and.(ihp.lt.i2))
            ihp=ihp+1
         enddo
         ihm=imi
         do while((y(ihm).lt.(y(imi)/2.)).and.(ihm.gt.i1))
            ihm=ihm-1
         enddo
         im=imi
      elseif (choice.eq.1) then
         ihp=ima
         do while((y(ihp).gt.(y(ima)/2.)).and.(ihp.lt.i2))
            ihp=ihp+1
         enddo
         ihm=ima
         do while((y(ihm).gt.(y(ima)/2.)).and.(ihm.gt.i1))
            ihm=ihm-1
         enddo
         im=ima
      else
         pause 'Error in Search()'
      endif

      xpos=x(im)
      ypos=y(im)

      width=abs(x(ihp)-x(ihm))
      if (x(ihp).gt.x(im)) then
         widthr=x(ihp)-x(im)
         if (ihp.gt.im) then
            ysumr=xyint(x,y,im,i2)
         else
            ysumr=xyint(x,y,i1,im)
         endif
         widthl=x(im)-x(ihm)
         if (ihm.gt.im) then
            ysuml=xyint(x,y,im,i2)
         else
            ysuml=xyint(x,y,i1,im)
         endif
      else
         widthr=x(ihm)-x(im)
         if (ihm.gt.im) then
            ysumr=xyint(x,y,im,i2)
         else
            ysumr=xyint(x,y,i1,im)
         endif
         widthl=x(im)-x(ihp)
         if (ihp.gt.im) then
            ysuml=xyint(x,y,im,i2)
         else
            ysuml=xyint(x,y,i1,im)
         endif
      endif

 304  format('position ',G12.4,' current ',G12.4,' width ',
     :     G12.4,' area ',G12.4) !
      if(idraw) then
         call plotline(xpos,0.,xpos,ypos)
         call plotline(x(ihp),ypos/2.,x(ihm),ypos/2)
      endif
      if (iprint) write(6,304) xpos,ypos,width,ysum
      
      return
      end


************************************************************

      subroutine searchpeaks(np,x,y,filename,ileng,case)
      parameter (N=2**14)
      real*4 x(*),y(*)
      integer ileng,case,choice
      character*128  filename
      character*1 code
      real*4 x4,y4
      real*4 xpos1,ypos1,width1,widthl1,widthr1,ysum1,ysuml1,ysumr1
      real*4 xpos2,ypos2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2
      real*8 xu,yu,xu2
      logical expert,click
      common /expert/ expert
c     case=1 1 peak, 2 2 peaks max or 2 peaks min, 3 2 peaks either max or min
 303  format(A)

      call plot(np,x,y,1)
      choice=0
c     1
      if(case.eq.1) then
         call search(np,x,y,1,np,choice,xpos1,ypos1,width1,widthl1,
     :     widthr1,ysum1,ysuml1,ysumr1,.true.,.true.) !
         call write9peaknew(filename,ileng,xpos1,ypos1,
     :        width1,widthl1,widthr1,ysum1,ysuml1,ysumr1) 
c     2/3
      elseif((case.eq.2).or.(case.eq.3)) then ! cliquer entre les deux pics.
         if (.not.expert) write(6,303) 'left button or b'//
     :        ' between the two peaks, then middle or q to exit' !
         code='0'
         click=.false.
         do while((.not.click).or.((code.ne.'&')
     :        .and.(code.ne.'Q'))) ! mid button or q ).and.( click=true
            call gr_curs(xu,yu,x4,y4,code)
            if ((.not.click).and.((code.eq.'&').or.(code.eq.'Q')))
     :           write(6,303) 'ERROR : click between the peaks first !' 
            if ((code.eq.'^').or.(code.eq.'B')) then
               click=.true.
               distmin=100.
               do i=1,np
                  dist=abs(xu-x(i))
                  if (dist.le.distmin) then 
                     distmin=dist
                     ic=i       ! c'est l'indice sur tableau x
                  endif
               enddo
            endif
         enddo                  ! xu est milieu
         call search(np,x,y,1,np,choice,xpos,ypos,width,widthl,
     :     widthr,ysum,ysuml,ysumr,.false.,.false.) !
         if(case.eq.2) then
            choice=-1
            if (ypos.gt.0) choice=1
         elseif(case.eq.3) then
            choice=0
         else
            pause 'ERROR in SearchPeaks()'
         endif
c     low potential=1
         if (xu.lt.x(np)) then
            call search(np,x,y,1,ic,choice,xpos1,ypos1,width1,widthl1,
     :           widthr1,ysum1,ysuml1,ysumr1,.true.,.true.) !
            call search(np,x,y,ic,np,choice,xpos2,ypos2,width2,widthl2,
     :           widthr2,ysum2,ysuml2,ysumr2,.true.,.true.) !
         else
            call search(np,x,y,ic,np,choice,xpos1,ypos1,width1,widthl1,
     :           widthr1,ysum1,ysuml1,ysumr1,.true.,.true.) !
            call search(np,x,y,1,ic,choice,xpos2,ypos2,width2,widthl2,
     :           widthr2,ysum2,ysuml2,ysumr2,.true.,.true.) !
         endif
         call write92peaksnew(filename,ileng,
     :        xpos1,ypos1,width1,widthl1,widthr1,ysum1,ysuml1,ysumr1,
     :        xpos2,ypos2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2)
c     4
      elseif (case.eq.4) then
         call search(np,x,y,1,np,1,xpos1,ypos1,width1,widthl1,
     :        widthr1,ysum1,ysuml1,ysumr1,.true.,.true.) !
         call search(np,x,y,1,np,-1,xpos2,ypos2,width2,widthl2,
     :        widthr2,ysum2,ysuml2,ysumr2,.true.,.true.) !
         if (xpos1.gt.xpos2) then
            call swap(xpos1,xpos2)
            call swap(ypos1,ypos2)
            call swap(width1,width2)
            call swap(widthl1,widthl2)
            call swap(widthr1,widthr2)
            call swap(ysum1,ysum2)
            call swap(ysuml1,ysuml2)
            call swap(ysumr1,ysumr2)
         endif
         YSUM1=0 ! MEANINGLESS
         YSUM2=0 
         call write92peaksnew(filename,ileng,
     :        xpos1,ypos1,width1,widthl1,widthr1,ysum1,ysuml1,ysumr1,
     :        xpos2,ypos2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2)
c     5
      elseif(case.eq.5) then
c     cliquer entre les deux pics
         if (.not.expert) write(6,303) 'left button or b between'//
     :        ' the two LOW POTENTIAL peaks, then middle or q to exit' !
         code='0'
         click=.false.
         do while((.not.click).or.((code.ne.'&').and.(code.ne.'Q')))
                                !     mid button or q ).and.( click=true
            call gr_curs(xu,yu,x4,y4,code)
            if ((code.eq.'^').or.(code.eq.'B')) then
               click=.true.
               distmin=100.
               do i=1,np
                  dist=abs(xu-x(i))
                  if (dist.le.distmin) then 
                     distmin=dist
                     ic=i       ! c'est l'indice sur tableau x
                  endif
               enddo
            endif
         enddo                  ! xu est milieu
         if (.not.expert) write(6,303)
     :        'again, between HIGH POTENTIAL peaks' !
         code='0'
         click=.false. 
c     mid button or q ).and.( click=true 
         do while((.not.click).or.((code.ne.'&').and.(code.ne.'Q')))   
            call gr_curs(xu,yu,x4,y4,code)
c     if ((code.eq.'&').or.(code.eq.'Q'))
c     write(6,303) 'ERROR : click between the peaks first !' !
            if ((code.eq.'^').or.(code.eq.'B')) then
               click=.true.
               distmin=100.
               do i=1,np
                  dist=abs(xu-x(i))
                  if (dist.le.distmin) then 
                     distmin=dist
                     ic2=i       ! c'est l'indice sur tableau x
                  endif
               enddo
            endif
         enddo                  ! xu2 est milieu
         choice=0
         if (x(1).lt.x(np)) then
            call search(np,x,y,1,ic,choice,xpos1,ypos1,width1,widthl1,
     :           widthr1,ysum1,ysuml1,ysumr1,.true.,.true.) !
            call search(np,x,y,ic,ic2,choice,xpos2,ypos2,width2,widthl2,
     :           widthr2,ysum2,ysuml2,ysumr2,.true.,.true.) !
            call search(np,x,y,ic2,np,choice,xpos3,ypos3,width3,widthl3,
     :           widthr3,ysum3,ysuml3,ysumr3,.true.,.true.) !
         else           
            call search(np,x,y,ic,np,choice,xpos1,ypos1,width1,widthl1,
     :           widthr1,ysum1,ysuml1,ysumr1,.true.,.true.) !
            call search(np,x,y,ic2,ic,choice,xpos2,ypos2,width2,widthl2,
     :           widthr2,ysum2,ysuml2,ysumr2,.true.,.true.) !
            call search(np,x,y,1,ic2,choice,xpos3,ypos3,width3,widthl3,
     :           widthr3,ysum3,ysuml3,ysumr3,.true.,.true.) !
         endif
         call write93peaksnew(filename,ileng,
     :        xpos1,ypos1,width1,widthl1,widthr1,ysum1,ysuml1,ysumr1,
     :        xpos2,ypos2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2,
     :        xpos3,ypos3,width3,widthl3,widthr3,ysum3,ysuml3,ysumr3)
      endif
      return
      end

************************************************************

C     Writes the given line to the output file.
      subroutine write_output_line(line, length)
      character*200 line
      integer length
      character*128 filename
      logical failed

      call open_output_file(failed)
      if(.not.failed) then
 304     format(A)
         write(9, 304) line(1:length)
         close(9)
      endif
      return

 305  format('ERROR during writing of ',A)
 24   write(6,305) filename(1:ileng)
      end

C     This routine opens the output file as unit 9 and make it ready
C     for appending
      subroutine open_output_file(failed)
      character*128 filename
      integer ileng
      common /outpeak/ filename, ileng
      logical backspacerequired
      common /backspacerequired/ backspacerequired
      logical ex, failed

      failed = .false.

      inquire(file=filename(1:ileng),exist=ex)
      open(unit=9,file=filename(1:ileng),status='unknown',err=24)
      if (ex) then
         do i=1,10000
            read(9,*,end=21)
         enddo
 21      continue
         if (backspacerequired) call backspace9
      endif
      return

 305  format('ERROR during the opening of the output file: ',A)
 24   write(6,305) filename(1:ileng)
      failed = .true.
      end

C     Writes a comment to the output file.
      subroutine write_comment_to_ouput_file
      character*200 comment, promptfor
      comment = promptfor('Comment: ', 'c')
      if(lnblnk(comment).ge.1) then
         call write_output_line(comment, lnblnk(comment))
      endif
      end


      subroutine write9peaknew(filenameopened,ilengo,xpos,yheight,
     :     width,widthl,widthr,ysum,ysuml,ysumr) 
      character*128 filename, filenameopened
      integer ileng, ilengo
      logical ex,backspacerequired
      real*4 xpos,yheight,width,leftwidth,rightwidth,ysum,ysuml,ysumr
      common /outpeak/ filename, ileng
      common /backspacerequired/ backspacerequired
      inquire(file=filename(1:ileng),exist=ex)
      open(unit=9,file=filename(1:ileng),status='unknown',err=24)
      if (ex) then
         do i=1,10000
            read(9,*,end=21)
         enddo
 21      continue
         if (backspacerequired.eqv..true.) call backspace9
      else
 303     format(A13,7(A12),A8)
         write(9,303)' position   ','height     ','width      ',
     :        'left-width ','right-width','area       ',
     :        'left-area  ','right-area ','filename'
      endif
 23   format (8(G12.4),A1,A)
      write(9,23,err=24) xpos,yheight,
     :     width,widthl,widthr,ysum,ysuml,ysumr
     :     ,' ',filenameopened(1:ilengo) !
 304  format('INFO : saved in ',A)
      write(6,304) filename(1:ileng)
      endfile 9
      close(9)
      return
 305  format('ERROR during writing of ',A)
 24   write(6,305) filename(1:ileng)
      return
      end
      
      subroutine write92peaksnew(filenameopened,ilengo,
     :     xpos1,yheight1,width1,widthl1,widthr1,ysum1,ysuml1,ysumr1,
     :     xpos2,yheight2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2)
      character*128 filename, filenameopened
      integer ileng, ilengo
      logical ex, backspacerequired
      common /outpeak/ filename, ileng
      common /backspacerequired/ backspacerequired
      inquire(file=filename(1:ileng),exist=ex)
      open(unit=9,file=filename(1:ileng),status='unknown',err=34)
      if (ex) then
         do i=1,10000
            read(9,*,end=31)
         enddo
 31      continue
         if (backspacerequired.eqv..true.) call backspace9
      else
 303     format(A13,15(A12),A8)
         write(9,303)
     :        ' position   ','height     ','width      ',
     :        'left-width ','right-width','area       ',
     :        'left-area  ','right-area ',
     :        'position   ','height     ','width      ',
     :        'left-width ','right-width','area       ',
     :        'left-area  ','right-area ','filename'
      endif         
 33   format (16(G12.4),A1,A)
      write(9,33,err=34)xpos1,yheight1,width1,widthl1,
     :     widthr1,ysum1,ysuml1,ysumr1, !
     :     xpos2,yheight2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2,
     :     ' ',filenameopened(1:ilengo)
      endfile 9
      close(9)
 304  format('INFO : saved in ',A)
      write(6,304) filename(1:ileng)
      return
 305  format('ERROR during writing of ',A)
 34   write(6,305) filename(1:ileng)
      return
      end

      subroutine write93peaksnew(filenameopened,ilengo,
     :     xpos1,yheight1,width1,widthl1,widthr1,ysum1,ysuml1,ysumr1,
     :     xpos2,yheight2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2,
     :     xpos3,yheight3,width3,widthl3,widthr3,ysum3,ysuml3,ysumr3)
      character*128 filename, filenameopened
      integer ileng, ilengo
      logical ex,backspacerequired
      common /outpeak/ filename, ileng
      common /backspacerequired/ backspacerequired
      inquire(file=filename(1:ileng),exist=ex)
      open(unit=9,file=filename(1:ileng),status='unknown',err=34)
      if (ex) then
         do i=1,10000
            read(9,*,end=31)
         enddo
 31      continue
         if (backspacerequired.eqv..true.) call backspace9
      else
 303     format(A13,24(A12),A8)
         write(9,303)
     :        ' position   ','height     ','width      ',
     :        'left-width ','right-width','area       ',
     :        'left-area  ','right-area ',
     :        ' position   ','height     ','width      ',
     :        'left-width ','right-width','area       ',
     :        'left-area  ','right-area ',
     :        'position   ','height     ','width      ',
     :        'left-width ','right-width','area       ',
     :        'left-area  ','right-area ','filename'
      endif         
 33   format (24(G12.4),A1,A)
      write(9,33,err=34) 
     :     xpos1,yheight1,width1,widthl1,widthr1,ysum1,ysuml1,ysumr1, !
     :     xpos2,yheight2,width2,widthl2,widthr2,ysum2,ysuml2,ysumr2, !
     :     xpos3,yheight3,width3,widthl3,widthr3,ysum3,ysuml3,ysumr3,
     :     ' ',filenameopened(1:ilengo)
      endfile 9
      close(9)
 304  format('INFO : saved in ',A)
      write(6,304) filename(1:ileng)
      return
 305  format('ERROR during writing of ',A)
 34   write(6,305) filename(1:ileng)
      return
      end

************************************************************
      
      subroutine erase
      character*128 filename, toto
      integer ileng
      logical backspacerequired
      common /outpeak/ filename, ileng
      common /backspacerequired/ backspacerequired
      open(unit=9,file=filename(1:ileng),status='unknown',err=34)
      do i=1,1000
         read(9,*,end=31)
      enddo
 31   continue
      if (backspacerequired.eqv..true.) call backspace9
      backspace 9
      endfile 9
      close(9)
      call cat
      return
 34   continue
 304  format('ERROR opening ',A,'. Sorry.')
      write(6,304)  filename(1:ileng)  
      return
      end
      
      subroutine cat
      character*128 filename
      integer ileng
      logical ex
      common /outpeak/ filename, ileng
      inquire(file=filename(1:ileng),exist=ex) ! file exists ?
      if (ex) then
 10      format('The peak file shown hereafter is ',A)
         write(6,10) filename(1:ileng)
         call soas_system('cat '//filename(1:ileng))
      else
 11      format('ERROR : file ',A,' does not exist.')
         write(6,11) filename(1:ileng)
 303     format(a)
         write(6,303) 'It will be created when you try to write in it' !
      endif
      return
      end

      subroutine openpeakdefault
      character*128 filename
      integer ileng
      common /outpeak/ filename, ileng
      filename(1:7)='out.dat'
      ileng=7
      return
      end

      subroutine setpeakfile
      character*128 filename,nfilename
      character*128 expandfile, promptfor
      
      integer*4 access,st
      integer lhome
      logical ex,expert
      common /expert/ expert
      common /outpeak/ filename, ileng 
 1    format(a)                 !(q,a)
      call soas_system("ls *.dat")
 303  format(A)
 304  format('INFO : Output file is ',A)
      write(6,304) filename(1:ileng)
      nfilename = promptfor ('New output filename ([abort]) :','f') 
      nfilename = expandfile(nfilename)
      ilengn=lnblnk(nfilename)
      if (ilengn.ne.0) then
         inquire(file=nfilename(1:ilengn),exist=ex)
         if (ex) then           ! exists
            st=access(nfilename(1:ilengn),'w')
            if (st.ne.0) then
               write(6,303) 'ERROR : You can''t access this file.'
               write(6,303) 'INFO  : Peak file NOT changed.'
            else
               write(6,303) 'INFO : This file already exists;'//
     :              ' results will be appended.' !
               ileng=ilengn
               filename(1:ileng)=nfilename(1:ileng)
               write(6,303) 'INFO : Peak file changed.'
            endif
         else                   ! does not ex
            ileng=ilengn
            filename(1:ileng)=nfilename(1:ileng)
            write(6,303) 'INFO : Peak file changed.'
            if (.not.expert) write(6,303) 'WARNING : I did not'//
     :           ' check that you can write this file' !  
         endif            
      else
         write(6,303) 'INFO : Peak file not changed'
      endif
      end


************************************************************
      subroutine cursor(npnew,xnew,ynew,filename,ileng,xe,ye,datachanged)
      parameter (N=2**14)
      real*4 xnew(*),ynew(*),xc(1),yc(1)
      integer ileng,ilengo
      integer marker            ! marker=1 on data, marker=2 smooth, 3 off data
      integer npnew
      character*128  filename,filenameo
      character*10 code
      real*8 xu,yu
      real*4 x4,y4,x4former
      logical datachanged,expert
      common /expert/ expert
      common /outpeak/ filenameo, ilengo
      save marker,x4
      x4former=x4
 303  format (A)
 304  format('X=',G12.4,' Y=',G12.4)
      if (.not.expert) then
         write(6,303) 's,x,o to switch between Smooth/eXact/Off_data' !
         write(6,303) 'left button to get user coordinates on screen'
         write(6,303) 'space to put coordinates in '//filenameo(1:ilengo)
         write(6,303) 'e to erase last line of '//filenameo(1:ilengo)
         write(6,303) 'c to see content of '//filenameo(1:ilengo)
         write(6,303) 'f to change output file'
         write(6,303) 'right button or q to quit'
         write(6,303) 'u to quit replacing data with data-y(cursor)'
      endif
      code=' '
      do while((code(1:1).ne.'*').and.
     :     (code(1:1).ne.'Q').and.(code(1:1).ne.'U')) ! right button or q

         if (marker.eq.1) then
            call gr_exec1('dr text 0 1 "Marker eXact" 3 /box 7') 
         elseif (marker.eq.2) then
            call gr_exec1('dr text 0 1 "Marker Smooth" 3 /box 7') 
         elseif (marker.eq.3) then
            call gr_exec1('dr text 0 1 "Marker Off data" 3 /box 7') 
         else
            marker=3
            call gr_exec1('dr text 0 1 "Marker Off data" 3 /box 7') 
         endif
         
         call gr_curs(xu,yu,x4,y4,code)
         call plot(npnew,xnew,ynew,1)
         
         if ((marker.ne.1).and.(code(1:1).eq.'X')) then ! exact
            marker=1
            if (.not.expert) write(6,303)
     :           'INFO : marker set to eXact' !
            
         elseif ((marker.eq.1).and.(code(1:1).eq.'X')) then ! exact
            if (.not.expert) write(6,303)
     :           'WARNING : marker already set to eXact' !
            
         elseif ((marker.ne.2).and.(code(1:1).eq.'S')) then ! smooth
            marker=2
            if (.not.expert) write(6,303)
     :           'INFO : marker set to Smooth' !
            
         elseif ((marker.eq.2).and.(code(1:1).eq.'S')) then ! smooth
            if (.not.expert) write(6,303)
     :           'WARNING : marker already set to Smooth' !
            
         elseif ((marker.ne.3).and.(code(1:1).eq.'O')) then ! off data
            marker=3
            if (.not.expert) write(6,303)
     :           'INFO : marker set to Off data' !

         elseif ((marker.eq.3).and.(code(1:1).eq.'O')) then ! off data 
            if (.not.expert) write(6,303)
     :           'WARNING : marker already set to Off data' !

         elseif (code(1:1).eq.'E') then
            call erase
         elseif (code(1:1).eq.'C') then
            call cat
         elseif (code(1:1).eq.'F') then
            call setpeakfile
            
         elseif ((code(1:1).eq.' ').or.
     :           (code(1:1).eq.'^')) then
            
            x4=xu         
            distmin=1e20
            do i=1,npnew
               if ((abs(x4-xnew(i))).lt.distmin) then
                  distmin=abs(x4-xnew(i))
                  ic=i
               endif
            enddo
            xc(1)=xnew(ic)
            if (marker.eq.1) then ! on data
               yc(1)=ynew(ic)
            elseif (marker.eq.2) then ! smooth
               yc(1)=smooth(npnew,xnew,ynew,ic)
            elseif (marker.eq.3) then ! out of data
               yc(1)=real(yu)
            endif

            call gr4_give('X',1,xc)
            call gr4_give('Y',1,yc)
            call gr_exec1('poi') ! plot markers

            if (code(1:1).eq.' ') then
               write(6,304) xc(1),yc(1) !
               call write9coord(filename,ileng,xc(1),yc(1)) 
            else
               write(6,304) xc(1),yc(1) !
            endif

         endif
      enddo
!      write(6,*) code(1:1),yc(1)
      if (code(1:1).eq.'U') then
         do i=1,npnew
            ynew(i)=ynew(i)-yc(1)
         enddo
         datachanged=.true.
      else
         datachanged=.false.
      endif

      xe=xc(1)
      ye=yc(1)

      return
      end
      
c$$$      subroutine cursor_old(filename,ileng)
c$$$      integer ileng,ilengo
c$$$      character*128  filename,filenameo
c$$$      character*10 code
c$$$      real*8 xu,yu
c$$$      real*4 x4,y4
c$$$      logical expert
c$$$      common /expert/ expert
c$$$      common /outpeak/ filenameo, ilengo
c$$$ 303  format (A)
c$$$ 304  format('X=',G12.4,' Y=',G12.4)
c$$$      if (.not.expert) then
c$$$         write(6,303) 'left button to get user coordinates on screen'
c$$$         write(6,303) 'space to put coordinates in '//filenameo(1:ilengo)
c$$$         write(6,303) 'e to erase last line of '//filenameo(1:ilengo)
c$$$         write(6,303) 'c to see content of '//filenameo(1:ilengo)
c$$$         write(6,303) 'o to change output file'
c$$$         write(6,303) 'right button or q to quit'
c$$$      endif
c$$$      code=' '
c$$$      do while((code(1:1).ne.'*').and.(code(1:1).ne.'Q')) ! right button
c$$$         call gr_curs(xu,yu,x4,y4,code)
c$$$         if (code(1:1).eq.' ') then
c$$$            write(6,304) xu,yu  !
c$$$            call write9coord(filename,ileng,xu,yu) 
c$$$         elseif (code(1:1).eq.'E') then
c$$$            call erase
c$$$         elseif (code(1:1).eq.'C') then
c$$$            call cat
c$$$         elseif (code(1:1).eq.'O') then
c$$$            call setpeakfile
c$$$         elseif ((code(1:1).ne.'*').and.(code(1:1).ne.'Q')) then
c$$$            write(6,304) xu,yu  !
c$$$         endif
c$$$      enddo
c$$$      return
c$$$      end


      subroutine write9coord(filenameopened,ilengo,xpos,ypos)
      character*128 filename, filenameopened
      integer ileng, ilengo
      logical ex,backspacerequired
c      real*8 xpos,ypos
      real*4 xpos,ypos
      common /outpeak/ filename, ileng
      common /backspacerequired/ backspacerequired
      
      inquire(file=filename(1:ileng),exist=ex)
      open(unit=9,file=filename(1:ileng),status='unknown',err=24)
      if (ex) then
         do i=1,10000
            read(9,*,end=21)
         enddo
 21      continue
         if (backspacerequired.eqv..true.) call backspace9
      else
 303     format(A13,2(A12))
         write(9,303)' x          ',' y         ',
     :        ' filename  '
      endif
 23   format (2(G12.4),A1,A)
      write(9,23,err=24) xpos,ypos
     :     ,' ',filenameopened(1:ilengo) !
 304  format('INFO : saved in ',A)
      write(6,304) filename(1:ileng)
      endfile 9
      close(9)
      return
 305  format('ERROR during writing of ',A)
 24   write(6,305) filename(1:ileng)
      return
      end


************************************************************
