C    soas_plot: some functions for communication with Greg
C    Copyright (C) 1999-2008  Christophe Leger
C                  2007, 2008 Vincent Fourmond
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License along
C    with this program; if not, write to the Free Software Foundation, Inc.,
C    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

      subroutine penreset
      call gr_exec1('pen /col 0 /da 1') ! weight 2
      return
      end

      subroutine initpageA4
      call gr_exec1('set plot_page 30 21')
      return
      end
      
      subroutine initpageLetter
      call gr_exec1('set plot_page 28 21')
      return
      end

      subroutine initgreg
      call gr_exec1('SET VIEWPORT 0.167 0.967 0.351 0.924')
      call gr_exec1('set mar 4 3 .2') ! normal marker size
      call gr_exec1('set char .6') ! character size
      call gr_exec1('tickspace 0 0 0 0') ! tick space auto
      call gr_exec1('set ticksize 0.3') ! tick size
      call gr_exec1('pen /da 1 /col 0') ! line shape (plain) and color (white)
      call gr_exec1('set blan 0 -1') ! remove blanking
      call gr_exec1('pen /w 2') ! weight 2
      return
      end

      subroutine lowerbox
      call gr_exec1('SET VIEWPORT 0.167 0.967 0.0714 0.31')
      return
      end

C     Get the page size from GreG, or make up one if that fails
      subroutine getpagesize(pagex, pagey)
      real pagex, pagey
      logical error

      call SIC_GET_REAL("page_x",pagex,error)
      call SIC_GET_REAL("page_y",pagey,error)
      if(error) then            ! Fill up with default values...
         pagex = 30
         pagey = 21
      endif

C 300  format("Page X: ", G12.4, "    Page Y: ", G12.4, " Error: ", L1)
C      write(6, 300) pagex, pagey, error

      end

      subroutine multibox(ntx,nty,i)
      character*128 A
      integer ntx,nty
      character*128 B
      real dx,dy,x1,y1,decalx,decaly,decalx1,pagex,pagey
c      ntx=5
c      nty=4
      nx=ntx-mod(ntx*nty-i,ntx)        !! 20, 5
      ny=int((ntx*nty-i)/ntx)+1
      decalx=1.5
      decaly=1.75
      decalx1=.5
      call getpagesize(pagex, pagey)
c      pagex=28 ! KRH -- need to set this within the limits of US paper
C      pagex=30.
c      pagey=21.


      dx=(pagex-(ntx+1)*decalx)/ntx
      dy=(pagey-(nty+1)*decaly)/nty
      x1=decalx+(dx+decalx)*(nx-1)
      y1=decaly+(dy+decaly)*(ny-1)
 301  format('set bo ',4(G12.4))
 302  format(A)
      write(B,301) x1+decalx1,x1+dx+decalx1,y1,y1+dy
      call exec_greg(B(1:55))

c     equivalent GREG macro
c$$$  on error return
c$$$  define real x1 y1 dx dy decalx decaly decalx1
c$$$  define integer nx ny ntx nty
c$$$  let decalx 1.5; let decaly 1.75; let decalx1 .5
c$$$  let nx &1; let ny &2; let ntx &3; let nty &4
c$$$  let dx (page_x-(ntx+1)*decalx)|ntx
c$$$  let dy (page_y-(nty+1)*decaly)|nty
c$$$  let x1 decalx+(dx+decalx)*(nx-1)
c$$$  let y1 decaly+(dy+decaly)*(ny-1)
c$$$  set bo x1+decalx1 x1+dx+decalx1 y1 y1+dy
c     i nx ny
c     1 1  4
c     2 2  4
c     ...
c     5 5  4
c     6 1  3
c     ...
c     20 5 1

      return
      end

      subroutine reclim(np,x,y) ! recover limits for data x,y
      real*4 x(*),y(*)
      call gr4_give('X',np,x)
      call gr4_give('Y',np,y)
      call gr_limi(0)
      call ZoomOut
      return
      end

      subroutine plotline(x1,y1,x2,y2) 
c     draw line between points (x1,y1) and (x2,y2) in user units
      parameter (ng=2)
      real x1,x2,y1,y2,xg(ng),yg(ng) !
      logical error
      xg(1)=x1
      xg(2)=x2
      yg(1)=y1
      yg(2)=y2
      call gr4_give('X',ng,xg)
      call gr4_give('Y',ng,yg)
      call gr_conn
      return
      end

      subroutine plot(np,x,y,ilim)
      parameter (N=2**14,Nstack=10,nc=2)      
      real*4 x(*),y(*)
      integer ilim,np,icol
      real*4 data(N,2*Nstack-1,nc) 
      integer nps(2*Nstack-1),n0
      logical marked(2*Nstack-1)
      character*128 filename(2*Nstack-1)
      character*128 chaine
      character*12 chainex,chainey
      integer ilengname(2*Nstack-1) 
      logical lastplotstack,expertmodeon,colorson
      common /stack/ data, nps, filename, ilengname
      common /mark/ marked
      common /lastplot/ lastplotstack
      common /expert/ expertmodeon
      common /colors/ colorson

 304  format (A,' (',I4,' points).')!+4+11
 305  format (A,' (#',I2,')')! +2+4

      n0=11+4+ilengname(Nstack)
      write(chaine(1:n0),304)
     :     filename(Nstack)(1:ilengname(Nstack)),nps(Nstack) !
      if (ilim.eq.10) then      ! plot marked
         if (np.eq.0) return    ! should not happen...
         call gr4_give('X',np,x) ! array transfer from soas' x and y...
         call gr4_give('Y',np,y) ! ... to Greg's X and Y
         call gr_clea(' ')      ! clear graph screen
         call gr_exec1('lim')   ! compute lim
         do i=1,2*Nstack-1
            if ((marked(i).eqv..true.)) then
               call gr4_give('X',nps(i),data(1,i,1)) ! array transfer from soas' x and y...
               call gr4_give('Y',nps(i),data(1,i,2)) ! ... to Greg's X and Y
               call gr_exec1('lim < > < >')
            endif
         enddo
         iname=0
         do i=1,2*Nstack-1
            if ((i.ne.nstack).and.(marked(i).eqv..true.)) then
               iname=iname+1
               call gr4_give('X',nps(i),data(1,i,1)) ! array transfer from soas' x and y...
               call gr4_give('Y',nps(i),data(1,i,2)) ! ... to Greg's X and Y
               n0=11+4+ilengname(i)
               write(chaine(1:n0),304)
     :              filename(i)(1:ilengname(i)),nps(i) !
 309           format('Overlaid buffer: ',A)
               if (.not.expertmodeon) write(6,309) chaine(1:n0) 
               if (colorson) then
                  call fcolor(iname)
               else
                  call fcolor(1)
               endif
               call gr_exec1('conn')
            endif
c     dealing with current buffer now, yellow, on top
c del christophe            call gr_exec1('pen /col 5') ! yellow
            call fcolor(0) 
            call gr_exec1('set orien 90') !
            n0=11+4+ilengname(Nstack)
            write(chaine(1:n0),304)
     :           filename(Nstack)(1:ilengname(Nstack)),nps(Nstack) !
            call gr_exec1
     :           ('dr text -3.5 0 "'//chaine(1:n0)//'" 5 /box 4') !
            call gr_exec1('set orien 0') !
            call gr4_give('X',nps(nstack),data(1,nstack,1)) ! array transfer from soas' x and y...
            call gr4_give('Y',nps(nstack),data(1,nstack,2)) ! ... to Greg's X and Y
            call gr_conn    
c            call gr_exec1('pen /col 0') 
            call fcolor(-1)
            call gr_box(' ')    ! draw box
         enddo
c     write all names, with appropriate color
         iname=0
c     call gr_exec1('pen /col 4') ! blue
         call gr_exec1('set char .45') 
         do i=1,2*Nstack-1
            if ((marked(i).eqv..true.).and.(i.ne.nstack)) then
               iname=iname+1
               n0=2+4+ilengname(i)
               write(chaine(1:n0),305)
     :              filename(i)(1:ilengname(i)),i ! print buffer number instead of number of points
 307           format(G12.4) 
               write(chainey,307) -1*mod(iname-1,5)-1.5
               write(chainex,307) mod(real((iname-1)/5),5.0)*6
 306           format(I2)
               if (colorson) then
                  call fcolor(iname)
                  call gr_exec1
     :                 ('dr text '//chainex//' '//chainey//' "'//
     :                 chaine(1:n0)//'" 6 /box 1')
                  call gr_exec1
     :                 ('dr re '//chainex//' '//chainey//'  /box 1')
                  call gr_exec1('dr re * Y_PEN-7.8') ! dunno really why...
                  call gr_exec1('dr li X_PEN+.5 *')  
               else
c                  call gr_exec1('pen /col 4') 
c                  call gr_exec1('pen /da 1') 
                  call fcolor(1)
                  call gr_exec1
     :                 ('dr text '//chainex//' '//chainey//' "'//
     :                 chaine(1:n0)//'" 6 /box 1')
               endif
            endif
         enddo
         call penreset ! def
      call gr_exec1('set char .6') ! character size
c     single data set plots
      else ! ilim.ne.10
         if (np.eq.0) return    ! shoud not happen...
         call gr4_give('X',np,x) ! array transfer from soas' x and y...
         call gr4_give('Y',np,y) ! ... to Greg's X and Y
         if (ilim.ge.1) then    ! new plot
            call gr_clea(' ')   ! clear graph screen
            call gr_exec1('lim') ! compute lim
            call ZoomOut        ! expand Y axis if iZoomOut gt 1
            call gr_box(' ')    ! draw box
            if (ilim.eq.1) then
c               call gr_exec1('pen /col 5') ! yellow
               call fcolor(0)
            elseif (ilim.eq.2) then
c               call gr_exec1('pen /col 4') ! blue
               call fcolor(1)
            endif
            call gr_conn        ! connect points
c            call gr_exec1('pen /col 5') ! yellow
            call fcolor(0)
            call gr_exec1('set orien 90') !
            call gr_exec1('dr text -3.5 0 "'//chaine(1:n0)
     :           //'" 5 /box 4') !
            call gr_exec1('set orien 0') !
            call penreset !
            if (marked(nstack).eqv..true.) then
c               call gr_exec1('pen /col 1') ! red
               call gr_exec1('dr text 1 -1 "*"  5 /box 7') !
c               call penreset ! yellow
            endif
         else                   ! overlay if ilim not .ge. 1
c            call gr_exec1('pen /col 4') ! blue
            call fcolor(1)
            if (ilim.eq.-1) then
               call gr_exec1('pen /da 3') ! dashed
c            elseif (ilim.eq.-2) then
c               call fcolor(1)
            endif
            call gr_conn        ! overlay data
         endif
c         call gr_exec1('pen /col 0') ! white
         call fcolor(-1)
c     markers if there are very few points and not overlay
         if ((ilim.eq.1).and.(np.le.50)) call gr_exec1('poi') 
         call penreset ! 
      endif
      lastplotstack=.false.
      return
      end

      subroutine charge2(x,y1,y2,np,areaold,displayratio)
      parameter (N=2**14) 
      integer np
      real*4 x(*),y2(*),y1(*),ytemp(N)
      real*4 areaold
      logical displayratio
      character*4 r1,r2
      character*128 ar
      common /ratio/ r1,r2
      ytemp(1)=0.
      do i=2, np                ! compute integral
         ytemp(i)=(y2(i)-y1(i))*(x(i)-x(i-1))+ytemp(i-1)
      enddo
 11   format('area : ',G10.3,', former area : ',G10.3)
      write(ar,11) ytemp(np), areaold
c      write(6,11) ytemp(np), areaold ! comment makes it crash...
      call gr_exec1('dr text 0 1 "'//ar(1:43)//'" 2 /box 8') 
      if (displayratio) then
         if (r1(1:4).eq.'*0  ') return 
      endif                     ! else draw ratio lines
      if (displayratio) then
         call gr4_give('X',np,x) ! array transfer
         call gr4_give('Y',np,ytemp)
         call gr_exec1('lim = = * *') ! old lim for x, new lim for y axis
         call gr_exec1('pen /col 2 /da 2') ! color = green
         call gr_conn           ! connect points
         call gr_exec1('pen /col 2 /da 3') ! color = green
         call gr_exec1('dr re user_xmin y[nxy]'//r1(1:4)//' /u') ! relocate
         call gr_exec1('dr li user_xmax y[nxy]'//r1(1:4)//' /u') ! draw line
         call gr_exec1('dr re user_xmin y[nxy]'//r2(1:4)//' /u') ! relocate
         call gr_exec1('dr li user_xmax y[nxy]'//r2(1:4)//' /u') ! draw line
         call penreset ! reset default color = white
      endif
      return
      end

      subroutine showfiltersize(s,x,np)
      real s,x(*)
      integer np,i1,i2
      character*12 x1,x2
      if (s.ne.0) then          ! indicates the size of the filter
         if (s.le.np) then
 310        format(G12.4)
c            call gr_exec1('pen /col 5') ! yellow
            call gr_exec1('pen /da 2 /col 1') ! red
            i1=int(np/2)-int(s/2)
            i2=int(np/2)+int(s/2)
            write(x2,310) x(i1)
            write(x1,310) x(i2)
            call gr_exec1('dr re '//x1//' user_ymax /u')
            call gr_exec1('dr li '//x2//' user_ymax /u')
         else
            call gr_exec1('pen /col 1') ! red
            call gr_exec1('dr re user_xmin user_ymax /u')
            call gr_exec1('dr li user_xmax user_ymax /u')
         endif
         call gr_exec1('pen /col 0') ! white
      endif
      return
      end

      subroutine plotdiff(x,y1,y2,s,np,ipeak)
c     plot difference between y1 and y2 (residual) in lower box
c     used for base line subtractions, spikes removal and filtering
      parameter (N=2**14)      
      real*4 x(*),y2(*),y1(*),ytemp(N),xtemp(N),s
      real*4 xpos,ypos,width,widthl,widthr,ysum,ysuml,ysumr ! dummy
      logical ipeak
      character*128 ar
      do i=1, np
         ytemp(i)=y2(i)-y1(i)   
      enddo
      call lowerbox
      call gr_exec1('dr text 0 -.5 "   residue" 3 /box 7') ! title
      call gr4_give('X',np,x) ! array transfer
      call gr4_give('Y',np,ytemp)
      call gr_exec1('lim = = * *') ! limits computed only for Y
      call gr_box(' ')          ! draw box
      call gr_exec1('pen /col 0') ! white
      call gr_conn              ! connect points
      call gr_exec1('pen /da 3')
      call gr_exec1('dr re user_xmin 0 /u') ! draw line y=0
      call gr_exec1('dr li user_xmax 0 /u')
      if (ipeak) then 
         call search(np,x,ytemp,1+int(s),np-int(s),0, ! ichoice=0
     :        xpos,ypos,width,widthl,widthr,
     :        ysum,ysuml,ysumr,.true.,.false.) !
         call initgreg          ! recover main box
 11      format('E(peak) : ',G10.3,', I(peak) : ',G10.3)
         write(ar,11) xpos,ypos
         call gr_exec1('dr text 0 1.65 "'//ar(1:44)//'" 2 /box 8') 
      else
      call initgreg             ! recover main box
      endif
      return
      end     

      subroutine plot_power(n,f,w1,w2)
      real f(*),w1(*),w2(*)
      character*12 xlim1
      integer n
      logical error
 1    format(G12.4)
      if (n.eq.0) return
      write(xlim1,1) 1./real(n)
      call lowerbox
      call gr_exec1('set blan 0 1e-50')
      call gr4_give('X',n,f)
      call gr4_give('Y',n,w1)
      call gr4_give('Z',n,w2)
C     For now, we don't sort anymore...
c      call gr_exec1('sort')     ! cause using realft() 
      call gr_exec1('lim  '//xlim1//' .55 * * /yl /xl')
      call gr_error(error)      ! for error recovery if no range Y; avoid crash
c     call gr_pen(2,5)          ! this seems to no longer work 
      call gr_exec1('pen /col 5') ! yellow
      call gr_exec1('histo') 
      call gr_exec1('dr text 0 -1.5 "   raw data" 3 /box 7') ! caption
c     call gr_pen(2,4)          ! idem
      call gr_exec1('pen /col 4') ! blue
      call exec_greg('let y z')
      call gr_exec1('histo') 
      call gr_exec1('dr text 0 -2.5 "   ffted data" 3 /box 7') ! caption
      call penreset ! 
      call gr_box(' ')          ! draw box
      call gr_exec1('dr text 0 -.5 "   power spectrum" 3 /box 7') ! title
      call initgreg
      return
      end

      subroutine browse(check_pt_off,
     :     listpattern, llistpattern,colformat)
      parameter (N=2**14)      
      integer ntx,nty
      real*4 x(N),y(N)
      character*128  filename,answer,directory
      integer ileng, ilengd
      character*24 soas_fdate        ! irix ? 
      character*128 soas_getcwd
      character*2 page
      integer ipage 
      external  soas_fdate,soas_getcwd
      logical expert,conf,check_pt_off
      character*128 listpattern  ! in load, save, browse
      integer llistpattern
      integer ndummyread        
      character*10 colformat
      logical lastplotstack
      character*128 promptfor, homefile
      common /expert/ expert
      common /lastplot/ lastplotstack
 1    format(a)                 !(q,a)
 2    format(I2)
 303  format(A)
      ntx=5
      nty=4
c     ntx=4                     
c     nty=3                     
      call soas_system('rm -f '// homefile('gregtmp/soas_f_l.tmp')) !
      if (llistpattern.ne.0) then
         call soas_system('ls -C1 ' // listpattern(1:llistpattern)//
     :        ' > '// homefile('gregtmp/soas_f_l.tmp'))
      else
         call soas_system('ls -C1 * > '
     :        //homefile('gregtmp/soas_f_l.tmp')) !
      endif
      open (unit=2,file=homefile('gregtmp/soas_f_l.tmp'),
     :     status='old',err=202) !
      call gr_clea(' ') 
      iwindow=0
      ipage=0
      call gr_exec1('set ticksize .2') ! small ticks
      call gr_exec1('set char .5') ! character size
      do j=1,N
         read(2,1,end=203) filename ! ileng,filename
         ileng=lnblnk(filename)
         iload=1
         call get_xy_from_file(filename,ileng,iload,np,x,y,colformat) ! in soas_file     
         if (check_pt_off) then
            call remove_points_off(np,x,y) 
         endif
         iwindow=iwindow+1
         if (iwindow.eq.(ntx*nty+1)) then
            answer(1:1)='0'
            do while((answer(1:1).ne.'m').and.
     :           (answer(1:1).ne.' ')) ! space is also OK
               if (expert) then
                  answer = promptfor('([m],f,q,p,z) >','s')
               else
                  answer = promptfor('More, Flush, Quit, Print,'//
     :                 ' Zoom ([m],f,q,p,z) ?','s') !
               endif 
               ilenga=lnblnk(answer)
               if (answer(1:1).eq.'q') then
                  call initgreg
                  lastplotstack=.false.
                  return
               elseif (answer(1:1).eq.'p') then
                  call confirm('print screen',12,conf,.true.) ! soas_main
                  if(conf) call printscreen ! soas_plot
               elseif (answer(1:1).eq.'z') then
                  call zoomscreen ! soas_plot
               elseif (answer(1:1).eq.'f') then
                  call gr_out   ! GTVL\flush 
               endif
            enddo
            call gr_clea(' ')   ! clear before next plot
            iwindow=1
         endif
         if (iwindow.eq.1) then ! write directory , page # and date
            call multibox(ntx,nty,1)
c     doesn't work if wd is too long, dunno why
c           call soas_system('echo $PWD')
            call gr_exec('dr text 0 1.5 "'//soas_getcwd()//'" 3 /box 7')
            call multibox(ntx,nty,ntx)
            call gr_exec('dr text 0 1.5 "'//soas_fdate()//'" 1 /box 9') 
            ipage=ipage+1
            write(page,2)ipage
            call multibox(ntx,nty,int((ntx+1)/2.)) !hhh
            call gr_exec('dr text 0 1.5 #"'//page//'" 2 /box 8') 
         endif
         call multibox(ntx,nty,iwindow)
         if (np.ne.0) then
            call gr4_give('X',np,x) ! array transfer
            call gr4_give('Y',np,y)
            call gr_exec1('lim') ! compute limits
            call gr_exec1('set char .3') ! character size for labels
            call gr_box(' ')    ! draw box
            call gr_exec1('set char .5') ! reset character size for names
            call fcolor(0)      ! yellow call gr_exec1('pen /col 5') ! yellow
            call gr_conn        ! connect points
            call fcolor(-1)     !white by default call gr_exec1('pen /col 0') ! white 
            write(6,303) filename(1:ileng)
            call gr_exec('dr text 0 .5 "'//filename(1:ileng)//
     :           '" 2 /box 8')
         else
            iwindow=iwindow-1
         endif
 201     continue
      enddo
c     stop                      ! 'should not be here'
 202  write(6,303) 'ERROR : you are not allowed to'//
     :     ' write temporary files in this directory.' !
      call initgreg
      close(2)
      lastplotstack=.false.
      return
 203  continue
      if (iwindow.eq.0) then
         write(6,303) 'No data files'
      else
         write(6,303) 'No more data files'
         if(expert) then
            answer = promptfor('([q],f,p,z) >','s')
         else
            answer = promptfor('Quit, Flush, Print, ' //
     :           'Zoom ([q],f,p,z) ?', 's') !
         endif
         ilenga=lnblnk(answer)
         if (answer(1:1).eq.'p') then
            call confirm('print screen',12,conf,.true.) ! soas_main
            if(conf) call printscreen
         elseif (answer(1:1).eq.'z') then
            call zoomscreen
         elseif (answer(1:1).eq.'f') then
            call gr_out
         endif
      endif
      call initgreg
      close(2)
      lastplotstack=.false.
      return
      end

      subroutine printscreen 
      logical colorson, rungv
      common /colors/ colorson
      common /rungv/ rungv
C     Remove before and after...
      call system("rm -f soas_tmp.ps")
      if (colorson) then
         call exec_greg('hard soas_tmp.ps /dev ps col')
      else
         call exec_greg('hard soas_tmp.ps /dev ps g')      
      endif
cC CL    We then call psresize to make sure the output file is
cC CL    of the right size:
c CL      call soas_system("psresize -pa4 soas_tmp.ps soas_tmp_resized.ps")
c CL      call soas_system("rm soas_tmp.ps")
      if (rungv) then
c         call soas_system("gv soas_tmp_resized.ps")
         call soas_system("gv soas_tmp.ps")
      else
c         call soas_system("lp soas_tmp_resized.ps")
c         call soas_system("psresize -pa4 soas_tmp.ps | lp")
         call soas_system("lp soas_tmp.ps")
      endif
C CL
      call system("rm -f soas_tmp.ps")
      return
      end

      subroutine saveps
      logical colorson
      character*128 filename, promptfor
      common /colors/ colorson
      integer ifile
      filename = promptfor("Name of file to save as: ", "f")
      ifile = lnblnk(filename)
      call soas_system("rm "//filename(1:ifile))
      if (colorson) then
         call exec_greg('hard '//filename(1:ifile)//' /dev ps col')
      else
         call exec_greg('hard '//filename(1:ifile)//' /dev ps g')      
      endif
      end


      subroutine zoomScreen
      logical expert
      common /expert/ expert
 303  format(A)
      if (.not.expert) then
         write(6,303) 'z or middle button to increase zooming factor'
         write(6,303) '- to decrease it'
         write(6,303) '0 to display the whole plot page (Zoom OFF)'
         write(6,303) 'space or left button to display'//
     :        ' the viewing window' !
         write(6,303) 'right button or e to quit'
c         write(6,303) '*** don''t forget to turn off'//
c     :        ' the zoom before exiting' !
      endif
      call gr_execl('zoom /curr')
      call gr_execl('zoom 0 30 0 23')
c      call gr_execl('zoom off') ! doesn't work
      call gr_execl('zoom refresh')
      return
      end

      subroutine ZoomOut        ! expand Y axis (iZoomOut times 1.25)
      integer iZoomOut
      common /zoom/ iZoomOut
      do i=1,iZoomOut
         call gr_exec1('lim = = (user_ymin+user_ymax)|'//
     :        '2-(user_ymax-((user_ymin+user_ymax)|2))*1.25 =') !
         call gr_exec1('lim = = = (user_ymin+user_ymax)|2+'//
     :        '(user_ymax-((user_ymin+user_ymax)|2))*1.25 ') !
      enddo
      return
      end

      subroutine wait
      call gr_exec('dr text 0 -1 "WAIT..." 2 /box 8')
      return
      end

      subroutine fcolor(iname)
      character*2 color,da
      integer iname
      logical colorson,alternatecolors
      common /colors/ colorson
      common /alternatecolors/ alternatecolors

      if (iname.eq.-1) then     ! white
         icolor=0
         ida=1
      elseif (iname.eq.0) then  ! yellow
         if (colorson) then
            icolor=0
         else
            if (.not.alternatecolors) then 
               icolor=5
            else !alternatecolors
               icolor=0
            endif
         endif
         ida=1
      elseif (iname.eq.1) then
         icolor=4
         ida=1
      elseif(iname.eq.2) then
         icolor=2
         ida=1
      elseif(iname.eq.3) then
         icolor=3
         ida=1
      elseif(iname.eq.4) then
         icolor=1
         ida=1
      elseif(iname.eq.5) then
         icolor=6
         ida=1
      elseif(iname.eq.6) then
         icolor=4
         ida=2
      elseif(iname.eq.7) then
         icolor=2
         ida=2
      elseif(iname.eq.8) then
         icolor=3
         ida=2
      elseif(iname.eq.9) then
         icolor=1
         ida=2
      elseif(iname.eq.10) then
         icolor=6
         ida=2
      elseif(iname.eq.11) then
         icolor=4
         ida=3
      elseif(iname.eq.12) then
         icolor=2
         ida=3
      elseif(iname.eq.13) then
         icolor=3
         ida=3
      elseif(iname.eq.14) then
         icolor=1
         ida=3
      elseif(iname.eq.15) then
         icolor=6
         ida=3
      elseif(iname.eq.16) then
         icolor=4
         ida=4
      elseif(iname.eq.17) then
         icolor=2
         ida=4
      elseif(iname.eq.18) then
         icolor=3
         ida=4
      elseif(iname.eq.19) then
         icolor=1
         ida=4
      elseif(iname.eq.20) then
         icolor=6
         ida=4
      endif
 306  format(I2)
      write(color,306) icolor
      write(da,306) ida
      call gr_exec1('pen /col '//color) 
      call gr_exec1('pen /da '//da) 

      return
      end
